View Issue Details

IDProjectCategoryView StatusLast Update
0038230FPCCompilerpublic2021-04-13 20:33
ReporterIgor Kokarev Assigned To 
PrioritynormalSeverityminorReproducibilityalways
Status newResolutionopen 
PlatformApple M1OSmacOS 
Product Version3.3.1 
Summary0038230: Exception in system functions on Apple M1
DescriptionThis problem is very similar to a problem in bug-report # 38189 "App aarch64 crashes on Apple M1".

Metal macOS function crashes with exception when called from non-main thread on Apple M1 aarch64/darwin:

copyFromTexture();

This problem doesn't occur with x86-64/darwin on Apple M1 using Rosetta.
Apple DTK works fine both versions aarch64 and x86-64. Probably because DTK doesn't have a hardware FPU exceptions?
Steps To ReproduceI attach a test project. Compile for aarch64/darwin.
Click "Render async" button. The app should generate rt.bmp image in the same folder.
aarch64/darwin app crashes immediatelly on Apple M1
Additional InformationApple M1. macOS 11.1, Xcode 12.3, Lazarus Trunk (December 17, 2020) and FPC Trunk 3.3.1 (December 17, 2020).

Project project1 raised exception class 'Debugger stopped with reason: EXC_BAD_INSTRUCTION (code=1, subcode=0x1e220820)'.
At address 115C9CEE0

0000000115C9CEC4 : 0x1e270183 fmov s3, w12
0000000115C9CEC8 : 0x1e235803 fmin s3, s0, s3
0000000115C9CECC : 0x1e39006c fcvtzu w12, s3
0000000115C9CED0 : 0x1200258c and w12, w12, #0x3ff
0000000115C9CED4 : 0x1e202008 fcmp s0, #0.0
0000000115C9CED8 : 0x9a8c43ec csel x12, xzr, x12, mi
0000000115C9CEDC : 0xf900000c str x12, [x0]
0000000115C9CEE0 : 0x1e220820 fmul s0, s1, s2
0000000115C9CEE4 : 0x1e202008 fcmp s0, #0.0
0000000115C9CEE8 : 0x52a88c0d mov w13, #0x44600000
0000000115C9CEEC : 0x1e2701a1 fmov s1, w13
0000000115C9CEF0 : 0x1e215800 fmin s0, s0, s1
0000000115C9CEF4 : 0x1e39000d fcvtzu w13, s0
0000000115C9CEF8 : 0x531625ad ubfiz w13, w13, 0000010, 0000010
0000000115C9CEFC : 0x9a8d43ed csel x13, xzr, x13, mi
0000000115C9CF00 : 0xaa0c01ac orr x12, x13, x12
0000000115C9CF04 : 0xf900000c str x12, [x0]
0000000115C9CF08 : 0x71000529 subs w9, w9, #0x1 ; =0x1
0000000115C9CF0C : 0x5ac01129 clz w9, w9
0000000115C9CF10 : 0x4b0903e9 neg w9, w9
0000000115C9CF14 : 0x5280002d mov w13, #0x1
0000000115C9CF18 : 0x1ac921a9 lsl w9, w13, w9
0000000115C9CF1C : 0x1a9f8529 csinc w9, w9, wzr, hi
0000000115C9CF20 : 0x5100052d sub w13, w9, #0x1 ; =0x1
0000000115C9CF24 : 0x5ac011ad clz w13, w13
0000000115C9CF28 : 0x4b0d53ed neg w13, w13, lsl 0000020
0000000115C9CF2C : 0x120c09ad and w13, w13, #0x700000
0000000115C9CF30 : 0x7100093f cmp w9, #0x2 ; =0x2
0000000115C9CF34 : 0x1a8d33e9 csel w9, wzr, w13, lo
0000000115C9CF38 : 0x7100011f cmp w8, #0x0 ; =0x0
0000000115C9CF3C : 0x9a8903e9 csel x9, xzr, x9, eq
0000000115C9CF40 : 0x7100011f cmp w8, #0x0 ; =0x0
0000000115C9CF44 : 0x1a9f07ed cset w13, ne
0000000000000000 ......
0000000000000000 ......

[FORMS.PP] ExceptionOccurred
  Sender=EAccessViolation
  Exception=Access violation
  Stack trace:
  $00000001109E0EE0
  $5678000110C966A8
  $47548001045D597C
  $00000001045D669C
  $00000001042E0E28
  $00000001042E0EB0
  $00000001042C4C68
[FORMS.PP] ExceptionOccurred
[FORMS.PP] ExceptionOccurred
[FORMS.PP] ExceptionOccurred
-[_MTLCommandEncoder dealloc]:131: failed assertion `Command encoder released without endEncoding'
Abort trap: 6

Full system log is attached in logs.txt.
TagsNo tags attached.
Fixed in Revision
FPCOldBugId
FPCTarget
Attached Files

Relationships

has duplicate 0038750 resolvedJonas Maebe SysInitFPU set FPU exceptions ignoring Math's ExceptionMask (AARCH64) 

Activities

Igor Kokarev

2020-12-18 16:21

reporter  

metal2.zip (60,145 bytes)
logs.txt (71,671 bytes)   
-------------------

Project project1 raised exception class 'Debugger stopped with reason: EXC_BAD_INSTRUCTION (code=1, subcode=0x1e220820)'.

At address 115C9CEE0


------------------

LLDB debugger:

0000000115C9CEC4                          : 0x1e270183   fmov   s3, w12
0000000115C9CEC8                          : 0x1e235803   fmin   s3, s0, s3
0000000115C9CECC                          : 0x1e39006c   fcvtzu w12, s3
0000000115C9CED0                          : 0x1200258c   and    w12, w12, #0x3ff
0000000115C9CED4                          : 0x1e202008   fcmp   s0, #0.0
0000000115C9CED8                          : 0x9a8c43ec   csel   x12, xzr, x12, mi
0000000115C9CEDC                          : 0xf900000c   str    x12, [x0]
0000000115C9CEE0                          : 0x1e220820   fmul   s0, s1, s2
0000000115C9CEE4                          : 0x1e202008   fcmp   s0, #0.0
0000000115C9CEE8                          : 0x52a88c0d   mov    w13, #0x44600000
0000000115C9CEEC                          : 0x1e2701a1   fmov   s1, w13
0000000115C9CEF0                          : 0x1e215800   fmin   s0, s0, s1
0000000115C9CEF4                          : 0x1e39000d   fcvtzu w13, s0
0000000115C9CEF8                          : 0x531625ad   ubfiz  w13, w13, #10, #10
0000000115C9CEFC                          : 0x9a8d43ed   csel   x13, xzr, x13, mi
0000000115C9CF00                          : 0xaa0c01ac   orr    x12, x13, x12
0000000115C9CF04                          : 0xf900000c   str    x12, [x0]
0000000115C9CF08                          : 0x71000529   subs   w9, w9, #0x1              ; =0x1 
0000000115C9CF0C                          : 0x5ac01129   clz    w9, w9
0000000115C9CF10                          : 0x4b0903e9   neg    w9, w9
0000000115C9CF14                          : 0x5280002d   mov    w13, #0x1
0000000115C9CF18                          : 0x1ac921a9   lsl    w9, w13, w9
0000000115C9CF1C                          : 0x1a9f8529   csinc  w9, w9, wzr, hi
0000000115C9CF20                          : 0x5100052d   sub    w13, w9, #0x1             ; =0x1 
0000000115C9CF24                          : 0x5ac011ad   clz    w13, w13
0000000115C9CF28                          : 0x4b0d53ed   neg    w13, w13, lsl #20
0000000115C9CF2C                          : 0x120c09ad   and    w13, w13, #0x700000
0000000115C9CF30                          : 0x7100093f   cmp    w9, #0x2                  ; =0x2 
0000000115C9CF34                          : 0x1a8d33e9   csel   w9, wzr, w13, lo
0000000115C9CF38                          : 0x7100011f   cmp    w8, #0x0                  ; =0x0 
0000000115C9CF3C                          : 0x9a8903e9   csel   x9, xzr, x9, eq
0000000115C9CF40                          : 0x7100011f   cmp    w8, #0x0                  ; =0x0 
0000000115C9CF44                          : 0x1a9f07ed   cset   w13, ne
0000000000000000 ......
0000000000000000 ......

----------------

GPU: <AGXM1Device: 0x1220cc600>
    name = Apple M1
<_MTLLibrary: 0x121f15bb0>
    label = <none> 
    device = <AGXM1Device: 0x1220cc600>
        name = Apple M1 
    functionNames: vertexShader fragmentShader
bundle path= /Users/mac/WnSoft/PTE/Tests/Graphics/
[FORMS.PP] ExceptionOccurred 
  Sender=EAccessViolation
  Exception=Access violation
  Stack trace:
  $00000001109E0EE0
  $5678000110C966A8
  $47548001045D597C
  $00000001045D669C
  $00000001042E0E28
  $00000001042E0EB0
  $00000001042C4C68
[FORMS.PP] ExceptionOccurred 
[FORMS.PP] ExceptionOccurred 
[FORMS.PP] ExceptionOccurred 
-[_MTLCommandEncoder dealloc]:131: failed assertion `Command encoder released without endEncoding'
Abort trap: 6
logout
Saving session...
...copying shared history...
...saving history...truncating history files...
...completed.

---------------

Process:               project1 [8217]
Path:                  /Users/USER/*/project1.app/Contents/MacOS/project1
Identifier:            com.company.project1
Version:               0.1 (1)
Code Type:             ARM-64 (Native)
Parent Process:        ??? [1]
Responsible:           project1 [8217]
User ID:               501

Date/Time:             2020-12-18 18:04:27.758 +0300
OS Version:            macOS 11.1 (20C69)
Report Version:        12
Anonymous UUID:        EEE544EF-CEE3-FF35-F1CF-04FD021BEC6D

Sleep/Wake UUID:       514C1796-B9A0-4BCE-BAA1-0EE8D0921AB3

Time Awake Since Boot: 19000 seconds
Time Since Wake:       2200 seconds

System Integrity Protection: enabled

Crashed Thread:        8

Exception Type:        EXC_BAD_INSTRUCTION (SIGABRT)
Exception Codes:       0x0000000000000001, 0x000000001e610808
Exception Note:        EXC_CORPSE_NOTIFY

Application Specific Information:
-[_MTLCommandEncoder dealloc]:131: failed assertion `Command encoder released without endEncoding'
 

Thread 0:: Dispatch queue: com.apple.main-thread
0   libsystem_kernel.dylib        	0x000000019213bce8 mach_msg_trap + 8
1   libsystem_kernel.dylib        	0x000000019213c098 mach_msg + 76
2   com.apple.CoreFoundation      	0x000000019226fe98 __CFRunLoopServiceMachPort + 380
3   com.apple.CoreFoundation      	0x000000019226e36c __CFRunLoopRun + 1216
4   com.apple.CoreFoundation      	0x000000019226d740 CFRunLoopRunSpecific + 600
5   com.apple.HIToolbox           	0x0000000199d8a678 RunCurrentEventLoopInMode + 292
6   com.apple.HIToolbox           	0x0000000199d8a4a8 ReceiveNextEventCommon + 688
7   com.apple.HIToolbox           	0x0000000199d8a1d8 _BlockUntilNextEventMatchingListInModeWithFilter + 76
8   com.apple.AppKit              	0x0000000194a45da4 _DPSNextEvent + 868
9   com.apple.AppKit              	0x0000000194a44724 -[NSApplication(NSEvent) _nextEventMatchingEventMask:untilDate:inMode:dequeue:] + 1312
10  com.company.project1          	0x0000000104d4a4e4 -[TCocoaApplication nextEventMatchingMask:untilDate:inMode:dequeue:] + 84 (cocoaint.pas:645)
11  com.company.project1          	0x0000000104d4abc0 COCOAINT$_$TCOCOAWIDGETSET_$__$$_APPRUNMESSAGES$BOOLEAN$NSDATE + 128 (cocoaobject.inc:92)
12  com.company.project1          	0x0000000104d4acac COCOAINT$_$TCOCOAWIDGETSET_$__$$_APPWAITMESSAGE + 60 (cocoaobject.inc:124)
13  com.company.project1          	0x0000000104bac4dc FORMS$_$TAPPLICATION_$__$$_IDLE$BOOLEAN + 220 (application.inc:394)
14  com.company.project1          	0x0000000104bae69c FORMS$_$TAPPLICATION_$__$$_HANDLEMESSAGE + 76 (application.inc:1206)
15  com.company.project1          	0x0000000104baec04 FORMS$_$TAPPLICATION_$__$$_RUNLOOP + 68 (application.inc:1324)
16  com.company.project1          	0x0000000104d49b50 -[TCocoaApplication run] + 64 (cocoaint.pas:468)
17  com.company.project1          	0x0000000104d4ab34 COCOAINT$_$TCOCOAWIDGETSET_$__$$_APPRUN$TAPPLICATIONMAINLOOP + 84 (cocoaobject.inc:78)
18  com.company.project1          	0x0000000104baebb4 FORMS$_$TAPPLICATION_$__$$_RUN + 100 (application.inc:1312)
19  com.company.project1          	0x0000000104b6c584 PASCALMAIN + 132 (project1.lpr:20)
20  com.company.project1          	0x0000000104b93c7c FPC_SysEntry + 28
21  com.company.project1          	0x0000000104b6c490 FPC_SYSTEMMAIN + 80
22  com.company.project1          	0x0000000104b6c4e8 main + 40
23  libdyld.dylib                 	0x0000000192190f34 start + 4

Thread 1:
0   libsystem_pthread.dylib       	0x000000019216fd8c start_wqthread + 0

Thread 2:
0   libsystem_pthread.dylib       	0x000000019216fd8c start_wqthread + 0

Thread 3:
0   libsystem_pthread.dylib       	0x000000019216fd8c start_wqthread + 0

Thread 4:
0   libsystem_pthread.dylib       	0x000000019216fd8c start_wqthread + 0

Thread 5:
0   libsystem_pthread.dylib       	0x000000019216fd8c start_wqthread + 0

Thread 6:
0   libsystem_pthread.dylib       	0x000000019216fd8c start_wqthread + 0

Thread 7:: com.apple.NSEventThread
0   libsystem_kernel.dylib        	0x000000019213bce8 mach_msg_trap + 8
1   libsystem_kernel.dylib        	0x000000019213c098 mach_msg + 76
2   com.apple.CoreFoundation      	0x000000019226fe98 __CFRunLoopServiceMachPort + 380
3   com.apple.CoreFoundation      	0x000000019226e36c __CFRunLoopRun + 1216
4   com.apple.CoreFoundation      	0x000000019226d740 CFRunLoopRunSpecific + 600
5   com.apple.AppKit              	0x0000000194bc5ddc _NSEventThread + 216
6   libsystem_pthread.dylib       	0x000000019217506c _pthread_start + 320
7   libsystem_pthread.dylib       	0x000000019216fda0 thread_start + 8

Thread 8 Crashed:
0   libsystem_kernel.dylib        	0x0000000192143cec __pthread_kill + 8
1   libsystem_pthread.dylib       	0x0000000192174c24 pthread_kill + 292
2   libsystem_c.dylib             	0x00000001920bc864 abort + 104
3   libsystem_c.dylib             	0x00000001920bbb14 __assert_rtn + 208
4   com.apple.Metal               	0x0000000199ab5510 MTLReportFailure.cold.1 + 56
5   com.apple.Metal               	0x0000000199aa2e8c MTLReportFailure + 468
6   com.apple.Metal               	0x0000000199a11378 -[_MTLCommandEncoder dealloc] + 128
7   libobjc.A.dylib               	0x0000000192030910 AutoreleasePoolPage::releaseUntil(objc_object**) + 204
8   libobjc.A.dylib               	0x000000019200fd00 objc_autoreleasePoolPop + 212
9   com.apple.CoreFoundation      	0x000000019222d160 _CFAutoreleasePoolPop + 32
10  com.apple.Foundation          	0x0000000192fb1f18 -[NSAutoreleasePool release] + 140
11  com.company.project1          	0x0000000104d4a804 COCOAINT_$$_INTERNALFINAL + 52 (cocoaint.pas:725)
12  com.company.project1          	0x0000000104b855e8 FPC_FINALIZEUNITS + 72
13  com.company.project1          	0x0000000104b859d4 SYSTEM_$$_INTERNALEXIT + 500
14  com.company.project1          	0x0000000104b85a2c FPC_DO_EXIT + 12
15  com.company.project1          	0x0000000104b85a84 SYSTEM_$$_HALT$LONGINT + 52
16  com.company.project1          	0x0000000104b99c3c FORMS_$$_EXCEPTIONOCCURRED$TOBJECT$POINTER$LONGINT$PPOINTER + 156 (forms.pp:1929)
17  com.company.project1          	0x0000000104b815bc SYSTEM_$$_DOUNHANDLEDEXCEPTION + 124
18  com.company.project1          	0x0000000104b819e8 FPC_RERAISE + 72
19  com.company.project1          	0x0000000104b99dfc FORMS_$$_EXCEPTIONOCCURRED$TOBJECT$POINTER$LONGINT$PPOINTER + 604
20  com.company.project1          	0x0000000104b815bc SYSTEM_$$_DOUNHANDLEDEXCEPTION + 124
21  com.company.project1          	0x0000000104b819e8 FPC_RERAISE + 72
22  com.company.project1          	0x0000000104b99dfc FORMS_$$_EXCEPTIONOCCURRED$TOBJECT$POINTER$LONGINT$PPOINTER + 604
23  com.company.project1          	0x0000000104b815bc SYSTEM_$$_DOUNHANDLEDEXCEPTION + 124
24  com.company.project1          	0x0000000104b819e8 FPC_RERAISE + 72
25  com.company.project1          	0x0000000104b99dfc FORMS_$$_EXCEPTIONOCCURRED$TOBJECT$POINTER$LONGINT$PPOINTER + 604
26  com.company.project1          	0x0000000104b815bc SYSTEM_$$_DOUNHANDLEDEXCEPTION + 124
27  com.company.project1          	0x0000000104b819e8 FPC_RERAISE + 72
28  com.company.project1          	0x0000000104bb4e6c UNIT1_$$_RENDER$WIDESTRING + 316
29  com.company.project1          	0x0000000104bb4eb0 UNIT1_$$_THREADFUNC$POINTER$$INT64 + 32 (unit1.pas:52)
30  com.company.project1          	0x0000000104b98c68 CTHREADS_$$_THREADMAIN$POINTER$$POINTER + 136
31  libsystem_pthread.dylib       	0x000000019217506c _pthread_start + 320
32  libsystem_pthread.dylib       	0x000000019216fda0 thread_start + 8

Thread 8 crashed with ARM Thread State (64-bit):
    x0: 0x0000000000000000   x1: 0x0000000000000000   x2: 0x0000000000000000   x3: 0x0000000000000000
    x4: 0x0000000000000000   x5: 0x0000000000000000   x6: 0x0000000000000000   x7: 0x0000000000000001
    x8: 0x00000000000005b9   x9: 0x3e6739d9af6cabfe  x10: 0xcccccccccccccccd  x11: 0x000000000000000a
   x12: 0x0000000000000000  x13: 0x0000000000000031  x14: 0x02000001100006b8  x15: 0x00000001fc1883e0
   x16: 0x0000000000000148  x17: 0x00000001f7b5f0b0  x18: 0x0000000000000000  x19: 0x0000000000000006
   x20: 0x000000016ba73000  x21: 0x0000000000014903  x22: 0x000000016ba730e0  x23: 0x00000001f2073000
   x24: 0x0000000000000010  x25: 0x00000001f222e000  x26: 0x0000000199ad0128  x27: 0x0000000000000000
   x28: 0x0000000000000000   fp: 0x000000016ba71f80   lr: 0x0000000192174c24
    sp: 0x000000016ba71f60   pc: 0x0000000192143cec cpsr: 0x40001000
   far: 0x000000010c738000  esr: 0x56000080


Binary Images:
       0x104b68000 -        0x104efffff +com.company.project1 (0.1 - 1) <21EF29F3-B3F2-34DD-AA22-02EDA7954FC7> /Users/USER/*/project1.app/Contents/MacOS/project1
       0x1058dc000 -        0x1058dffff  libCyrillicConverter.dylib (90) <F70D5AE2-F15B-37A4-BF7D-F9EBA5BC1AA5> /System/Library/CoreServices/Encodings/libCyrillicConverter.dylib
       0x105a04000 -        0x105a7ffff  dyld (832.7.1) <B7DB9E8A-A898-3C11-91A0-2B0264F05CB6> /usr/lib/dyld
       0x109838000 -        0x109843fff  libobjc-trampolines.dylib (818.2) <10840110-16BD-3EB2-B9CF-CCAB42259740> /usr/lib/libobjc-trampolines.dylib
       0x10b000000 -        0x10b4fffff  com.apple.AGXMetal13-3 (172.20.14 - 172.20.14) <1352B37A-9D23-3610-BDEE-C054980814BD> /System/Library/Extensions/AGXMetal13_3.bundle/Contents/MacOS/AGXMetal13_3
       0x191ed2000 -        0x191ed3fff  libsystem_blocks.dylib (78) <D3998C8A-7A1C-3962-822C-91DFC11ACBF7> /usr/lib/system/libsystem_blocks.dylib
       0x191ed4000 -        0x191f0bfff  libxpc.dylib (2038.40.38) <D87D7BAA-9E73-3A84-8247-3456B703C302> /usr/lib/system/libxpc.dylib
       0x191f0c000 -        0x191f23fff  libsystem_trace.dylib (1277.50.1) <D67123A1-A8BC-329C-BC76-830E95EBA1B3> /usr/lib/system/libsystem_trace.dylib
       0x191f24000 -        0x191f97fff  libcorecrypto.dylib (1000.60.19) <D6B8B5AA-56DF-3E47-A778-007A7AA81372> /usr/lib/system/libcorecrypto.dylib
       0x191f98000 -        0x191fc3fff  libsystem_malloc.dylib (317.40.8) <E47334AF-7E46-3FAE-B71C-9D9B4F1DF1DE> /usr/lib/system/libsystem_malloc.dylib
       0x191fc4000 -        0x192007fff  libdispatch.dylib (1271.40.12) <68CAA910-6621-32A1-95AE-40594BA75013> /usr/lib/system/libdispatch.dylib
       0x192008000 -        0x192040fff  libobjc.A.dylib (818.2) <A4BC7D83-2CA5-32B1-B1CA-1D1431C04916> /usr/lib/libobjc.A.dylib
       0x192041000 -        0x192043fff  libsystem_featureflags.dylib (28.60.1) <790541FA-8846-39B1-B87F-BCB1C87A6A27> /usr/lib/system/libsystem_featureflags.dylib
       0x192044000 -        0x1920c4fff  libsystem_c.dylib (1439.40.11) <4A324485-84D9-318F-8267-70FF10504289> /usr/lib/system/libsystem_c.dylib
       0x1920c5000 -        0x192120fff  libc++.1.dylib (904.4) <28BA0783-4F54-33EB-8DC0-DC23CD3BC576> /usr/lib/libc++.1.dylib
       0x192121000 -        0x19213afff  libc++abi.dylib (904.4) <9291CD18-15AA-33CB-96FD-C5CB7F500470> /usr/lib/libc++abi.dylib
       0x19213b000 -        0x19216dfff  libsystem_kernel.dylib (7195.60.75) <35BFD663-2C38-3E0F-A35E-8C1BC6400898> /usr/lib/system/libsystem_kernel.dylib
       0x19216e000 -        0x192179fff  libsystem_pthread.dylib (454.60.1) <EDB716F3-BF94-3941-B7DA-D6C91094C645> /usr/lib/system/libsystem_pthread.dylib
       0x19217a000 -        0x1921b8fff  libdyld.dylib (832.7.1) <87B502C5-584E-381A-8C99-6105402B8A6E> /usr/lib/system/libdyld.dylib
       0x1921b9000 -        0x1921bffff  libsystem_platform.dylib (254.60.1) <089E074F-F575-3853-B081-B3B0A23FDA61> /usr/lib/system/libsystem_platform.dylib
       0x1921c0000 -        0x1921ebfff  libsystem_info.dylib (542.40.3) <CFE4640F-4E04-3DC5-80F6-79E0BF7F4FAF> /usr/lib/system/libsystem_info.dylib
       0x1921ec000 -        0x192695fff  com.apple.CoreFoundation (6.9 - 1770.300) <396F9604-7574-3C1B-ACA7-C7EB24FE3544> /System/Library/Frameworks/CoreFoundation.framework/Versions/A/CoreFoundation
       0x192696000 -        0x1928c8fff  com.apple.LaunchServices (1122.11 - 1122.11) <D9D92910-FF1A-3868-ABB6-C0E1A256A95B> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/LaunchServices.framework/Versions/A/LaunchServices
       0x1928c9000 -        0x1929a1fff  com.apple.gpusw.MetalTools (1.0 - 1) <93384C15-675B-3BB6-989E-A5C3450B9D64> /System/Library/PrivateFrameworks/MetalTools.framework/Versions/A/MetalTools
       0x1929a2000 -        0x192bfcfff  libBLAS.dylib (1336.40.1) <7BF1EC0C-692E-3D4A-AD4E-0C8C29C4C178> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libBLAS.dylib
       0x192bfd000 -        0x192c47fff  com.apple.Lexicon-framework (1.0 - 86.1) <38A45B37-F56D-3077-AE41-202435470BD0> /System/Library/PrivateFrameworks/Lexicon.framework/Versions/A/Lexicon
       0x192c48000 -        0x192caafff  libSparse.dylib (106) <8E6B9AAB-79F7-3ADA-B7CF-DD0FA0DBBCE8> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libSparse.dylib
       0x192cab000 -        0x192d32fff  com.apple.SystemConfiguration (1.20 - 1.20) <9DDF8F69-ED1D-3CF5-8BE5-45D2D2D32DF1> /System/Library/Frameworks/SystemConfiguration.framework/Versions/A/SystemConfiguration
       0x192d33000 -        0x192d66fff  libCRFSuite.dylib (50) <29C89933-ADA1-359A-9E5B-CF3A5B4A618E> /usr/lib/libCRFSuite.dylib
       0x192d67000 -        0x192f91fff  libmecabra.dylib (929.1.1) <3CDA7E90-E5E4-3C5B-AA24-FF880AF18D0E> /usr/lib/libmecabra.dylib
       0x192f92000 -        0x193323fff  com.apple.Foundation (6.9 - 1770.300) <5CEA7350-F274-39AE-9F27-D9813F2C3A76> /System/Library/Frameworks/Foundation.framework/Versions/C/Foundation
       0x193324000 -        0x193415fff  com.apple.LanguageModeling (1.0 - 247.1) <4D0D7198-4EB8-3D57-93E7-6F1F7EF4437C> /System/Library/PrivateFrameworks/LanguageModeling.framework/Versions/A/LanguageModeling
       0x193416000 -        0x193538fff  com.apple.CoreDisplay (231.3 - 231.3) <C5041E8F-8A23-3EF8-8F45-E9A80452B397> /System/Library/Frameworks/CoreDisplay.framework/Versions/A/CoreDisplay
       0x193539000 -        0x1937a6fff  com.apple.audio.AudioToolboxCore (1.0 - 1180.23) <70295FDE-F110-3D9F-B696-D8E4995D2FE4> /System/Library/PrivateFrameworks/AudioToolboxCore.framework/Versions/A/AudioToolboxCore
       0x1937a7000 -        0x193978fff  com.apple.CoreText (677.2.0.5 - 677.2.0.5) <AE3C151D-2022-3A70-9DE4-FA773BF55FDB> /System/Library/Frameworks/CoreText.framework/Versions/A/CoreText
       0x193979000 -        0x193f9dfff  com.apple.audio.CoreAudio (5.0 - 5.0) <0E6AD3C8-3E90-3CB7-BE25-DDD37AFD1917> /System/Library/Frameworks/CoreAudio.framework/Versions/A/CoreAudio
       0x193f9e000 -        0x1942fbfff  com.apple.security (7.0 - 59754.60.13) <495AE9B1-FAB5-3409-A758-B837B872CD61> /System/Library/Frameworks/Security.framework/Versions/A/Security
       0x1942fc000 -        0x19456dfff  libicucore.A.dylib (66109) <CFFBBD7C-F4CB-3D78-AD6C-86901ECE567F> /usr/lib/libicucore.A.dylib
       0x19456e000 -        0x194578fff  libsystem_darwin.dylib (1439.40.11) <1DEB48CE-5F39-3BBC-8D13-00C7636F7FE5> /usr/lib/system/libsystem_darwin.dylib
       0x194579000 -        0x194868fff  com.apple.CoreServices.CarbonCore (1307 - 1307) <4A7CBA4E-46D7-3C12-9E87-20C15E4FACE6> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/CarbonCore.framework/Versions/A/CarbonCore
       0x194869000 -        0x1948a3fff  com.apple.CoreServicesInternal (476 - 476) <1308E62B-1210-3F6A-98AA-7D0C527C6162> /System/Library/PrivateFrameworks/CoreServicesInternal.framework/Versions/A/CoreServicesInternal
       0x1948a4000 -        0x1948dffff  com.apple.CSStore (1122.11 - 1122.11) <1B34F90E-E298-3EF6-904F-6903CDEF72EF> /System/Library/PrivateFrameworks/CoreServicesStore.framework/Versions/A/CoreServicesStore
       0x1948e0000 -        0x1949aafff  com.apple.framework.IOKit (2.0.2 - 1845.60.2) <B0586F3E-D933-32E2-A51A-3B0DC242DB5F> /System/Library/Frameworks/IOKit.framework/Versions/A/IOKit
       0x1949ab000 -        0x1949b6fff  libsystem_notify.dylib (279.40.4) <C8ADD6C0-5150-359F-8A38-AEAA3351AA5C> /usr/lib/system/libsystem_notify.dylib
       0x1949b7000 -        0x194a03fff  libsandbox.1.dylib (1441.60.4) <010546C0-030F-3E97-8CDF-4AA5665917FA> /usr/lib/libsandbox.1.dylib
       0x194a04000 -        0x195762fff  com.apple.AppKit (6.9 - 2022.20.119) <78F21674-643E-3793-B1CD-C8BDBC76BAD5> /System/Library/Frameworks/AppKit.framework/Versions/C/AppKit
       0x195763000 -        0x195990fff  com.apple.UIFoundation (1.0 - 726.11) <085965EE-A855-340D-8022-805BB9F45A87> /System/Library/PrivateFrameworks/UIFoundation.framework/Versions/A/UIFoundation
       0x195991000 -        0x1959a3fff  com.apple.UniformTypeIdentifiers (633.0.2 - 633.0.2) <894D4234-E2B3-3154-B7C5-C7C1042100A0> /System/Library/Frameworks/UniformTypeIdentifiers.framework/Versions/A/UniformTypeIdentifiers
       0x1959a4000 -        0x195b12fff  com.apple.desktopservices (1.17 - 1346.2.1) <9FB6D481-1E7B-3A98-AB83-B6F7BF988AF9> /System/Library/PrivateFrameworks/DesktopServicesPriv.framework/Versions/A/DesktopServicesPriv
       0x195dcc000 -        0x1964d6fff  libnetwork.dylib (2288.60.5) <A9B6599B-C0A3-3E26-93A4-0BCCCCDB5D30> /usr/lib/libnetwork.dylib
       0x1964d7000 -        0x196964fff  com.apple.CFNetwork (1209.1 - 1209.1) <BE1B59DE-CE44-3CAE-897A-735E500ABB73> /System/Library/Frameworks/CFNetwork.framework/Versions/A/CFNetwork
       0x196965000 -        0x196974fff  libsystem_networkextension.dylib (1295.60.5) <399ACCA2-77CA-3A30-9930-1382F8DBBAD3> /usr/lib/system/libsystem_networkextension.dylib
       0x196975000 -        0x196976fff  libenergytrace.dylib (22) <2AE008F9-387E-3386-8324-27E5A1574598> /usr/lib/libenergytrace.dylib
       0x196977000 -        0x1969cbfff  libMobileGestalt.dylib (978.60.2) <D8DD322B-F5E3-3398-B549-51AF91E7935D> /usr/lib/libMobileGestalt.dylib
       0x1969cc000 -        0x1969e3fff  libsystem_asl.dylib (385) <B25E1954-9781-3238-8B1C-0CF44B5FA684> /usr/lib/system/libsystem_asl.dylib
       0x1969e4000 -        0x1969fdfff  com.apple.TCC (1.0 - 1) <E0CEAEA4-8553-31F2-831B-35D8443CA4A3> /System/Library/PrivateFrameworks/TCC.framework/Versions/A/TCC
       0x1969fe000 -        0x196d63fff  com.apple.SkyLight (1.600.0 - 569.6) <936C1A3C-0381-3277-B5A2-29333312F86F> /System/Library/PrivateFrameworks/SkyLight.framework/Versions/A/SkyLight
       0x196d64000 -        0x197351fff  com.apple.CoreGraphics (2.0 - 1463.2.2) <D6C003BF-A49F-37E4-ADE1-31AFA72DDB41> /System/Library/Frameworks/CoreGraphics.framework/Versions/A/CoreGraphics
       0x197352000 -        0x197447fff  com.apple.ColorSync (4.13.0 - 3472) <DFF79761-3AF6-33F4-BAD2-8A276AECE01D> /System/Library/Frameworks/ColorSync.framework/Versions/A/ColorSync
       0x197448000 -        0x1974a3fff  com.apple.HIServices (1.22 - 713) <314B0EC5-1646-3A34-9A1B-FB3CE405EC29> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/HIServices.framework/Versions/A/HIServices
       0x1977ff000 -        0x197bb0fff  com.apple.CoreData (120 - 1044.3) <0DFDE2DB-2C07-3DBE-872E-CFD24D675C43> /System/Library/Frameworks/CoreData.framework/Versions/A/CoreData
       0x197bb1000 -        0x197bc8fff  com.apple.ProtocolBuffer (1 - 285.20.8.8.1) <A2A5B698-8017-3DCE-BD07-C9CC7A807B95> /System/Library/PrivateFrameworks/ProtocolBuffer.framework/Versions/A/ProtocolBuffer
       0x197bc9000 -        0x197d70fff  libsqlite3.dylib (321.1) <23EE8E77-50C4-35E8-A3C7-04C71FBD8565> /usr/lib/libsqlite3.dylib
       0x197d71000 -        0x197de8fff  com.apple.Accounts (113 - 113) <718942B7-C0EF-3B33-861B-5BA79D5A1A92> /System/Library/Frameworks/Accounts.framework/Versions/A/Accounts
       0x197de9000 -        0x197e00fff  com.apple.commonutilities (8.0 - 900) <49536612-8785-3D31-A128-266D79ADC772> /System/Library/PrivateFrameworks/CommonUtilities.framework/Versions/A/CommonUtilities
       0x197e01000 -        0x197e85fff  com.apple.BaseBoard (526 - 526) <7A3F1C5D-442D-35AB-8B63-D13EC7638F1A> /System/Library/PrivateFrameworks/BaseBoard.framework/Versions/A/BaseBoard
       0x197e86000 -        0x197ed6fff  com.apple.RunningBoardServices (1.0 - 505.60.2) <C1D71AE3-7493-3A7C-9717-EB6A6BFE451E> /System/Library/PrivateFrameworks/RunningBoardServices.framework/Versions/A/RunningBoardServices
       0x197ed7000 -        0x197f4afff  com.apple.AE (918.0.1 - 918.0.1) <311D1113-C432-3442-BB70-8605090A5E5C> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/AE.framework/Versions/A/AE
       0x197f4b000 -        0x197f52fff  libdns_services.dylib (1310.60.4) <8FFC83B0-344F-3FE7-8FA9-8AE1AAFB99BB> /usr/lib/libdns_services.dylib
       0x197f53000 -        0x197f5afff  libsystem_symptoms.dylib (1431.60.1) <CF9E7636-168A-36DD-95F0-6CA76B91D3DC> /usr/lib/system/libsystem_symptoms.dylib
       0x197f5b000 -        0x1980b7fff  com.apple.Network (1.0 - 1) <6112E930-7DB0-369D-9536-930C8C3CD690> /System/Library/Frameworks/Network.framework/Versions/A/Network
       0x1980b8000 -        0x1980ddfff  com.apple.analyticsd (1.0 - 1) <4CDE85B1-CEAF-3EF9-ADB2-8A3D3FD5AAB4> /System/Library/PrivateFrameworks/CoreAnalytics.framework/Versions/A/CoreAnalytics
       0x1980de000 -        0x1980e0fff  libDiagnosticMessagesClient.dylib (112) <BD85EAE3-2614-3867-83D8-0DBE045856A2> /usr/lib/libDiagnosticMessagesClient.dylib
       0x1980e1000 -        0x19812cfff  com.apple.spotlight.metadata.utilities (1.0 - 2150.7.2) <2A982B2F-4F96-31DB-89CC-37445DF62FDE> /System/Library/PrivateFrameworks/MetadataUtilities.framework/Versions/A/MetadataUtilities
       0x19812d000 -        0x1981c6fff  com.apple.Metadata (10.7.0 - 2150.7.2) <FA920EDA-E34F-3C8F-9565-EA0695E8C371> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/Metadata.framework/Versions/A/Metadata
       0x1981c7000 -        0x1981cdfff  com.apple.DiskArbitration (2.7 - 2.7) <07975F48-4A37-3FD9-9DD2-3367AAE9D692> /System/Library/Frameworks/DiskArbitration.framework/Versions/A/DiskArbitration
       0x1981ce000 -        0x1984ecfff  com.apple.vImage (8.1 - 544) <818B9B01-AA84-3D24-A04D-00EA8D66C14F> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vImage.framework/Versions/A/vImage
       0x1984ed000 -        0x19879ffff  com.apple.QuartzCore (1.11 - 925.5) <0FB3C46F-6DDF-3FDD-BF81-BF62A7553659> /System/Library/Frameworks/QuartzCore.framework/Versions/A/QuartzCore
       0x1987a0000 -        0x1987e2fff  libFontRegistry.dylib (309) <6901EFA1-C468-3C81-96A6-8B173C0E9B2B> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ATS.framework/Versions/A/Resources/libFontRegistry.dylib
       0x1987e3000 -        0x1988fcfff  com.apple.coreui (2.1 - 689.4) <6B6F13C9-A49E-3B86-A23A-FE783177B980> /System/Library/PrivateFrameworks/CoreUI.framework/Versions/A/CoreUI
       0x1988fd000 -        0x1989ddfff  com.apple.ViewBridge (551.3 - 551.3) <4F02AAF6-773F-33B3-A881-8FE458C996B2> /System/Library/PrivateFrameworks/ViewBridge.framework/Versions/A/ViewBridge
       0x1989de000 -        0x1989e8fff  com.apple.PerformanceAnalysis (1.275 - 275) <8A942FDF-004C-373E-83A8-46D5F918B377> /System/Library/PrivateFrameworks/PerformanceAnalysis.framework/Versions/A/PerformanceAnalysis
       0x1989e9000 -        0x1989f6fff  com.apple.OpenDirectory (11.1 - 230.40.1) <BF1D3476-D716-3AC4-8266-BF8E63A5F4C4> /System/Library/Frameworks/OpenDirectory.framework/Versions/A/OpenDirectory
       0x1989f7000 -        0x198a16fff  com.apple.CFOpenDirectory (11.1 - 230.40.1) <94AFB779-A06B-3AE4-8609-E9FDEF6DCF4E> /System/Library/Frameworks/OpenDirectory.framework/Versions/A/Frameworks/CFOpenDirectory.framework/Versions/A/CFOpenDirectory
       0x198a17000 -        0x198a1ffff  com.apple.CoreServices.FSEvents (1290.40.2 - 1290.40.2) <09DE727C-4BA5-33B7-9811-5F0CA5C86F31> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/FSEvents.framework/Versions/A/FSEvents
       0x198a20000 -        0x198a44fff  com.apple.coreservices.SharedFileList (144 - 144) <44F30AE5-8DC1-3726-8D6E-8811972BDB60> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/SharedFileList.framework/Versions/A/SharedFileList
       0x198a45000 -        0x198a47fff  libapp_launch_measurement.dylib (14.1) <EE51FF2D-B44F-3027-92BA-42E0FDA6578C> /usr/lib/libapp_launch_measurement.dylib
       0x198a48000 -        0x198a8bfff  com.apple.CoreAutoLayout (1.0 - 21.10.1) <289ACB53-3AFD-3898-9867-BDD113D0F249> /System/Library/PrivateFrameworks/CoreAutoLayout.framework/Versions/A/CoreAutoLayout
       0x198a8c000 -        0x198b77fff  libxml2.2.dylib (34.8) <27B1CD43-A3F5-38D6-8AF5-B5F1977E5EA5> /usr/lib/libxml2.2.dylib
       0x198b78000 -        0x198bcafff  com.apple.CoreVideo (1.8 - 408.4) <B877220F-1199-3F9F-B00E-2DD96231D7DF> /System/Library/Frameworks/CoreVideo.framework/Versions/A/CoreVideo
       0x198bcb000 -        0x198bcdfff  com.apple.loginsupport (1.0 - 1) <08ABC43D-FFEE-3F47-804A-D2510D814E42> /System/Library/PrivateFrameworks/login.framework/Versions/A/Frameworks/loginsupport.framework/Versions/A/loginsupport
       0x198bf6000 -        0x198c15fff  com.apple.UserManagement (1.0 - 1) <6B3CD796-2A5C-3613-BAC3-AA7BD125D26B> /System/Library/PrivateFrameworks/UserManagement.framework/Versions/A/UserManagement
       0x1999c4000 -        0x1999d5fff  libsystem_containermanager.dylib (318.60.1) <165B6DCF-6B92-3EC9-84D3-98FBFAB26EA1> /usr/lib/system/libsystem_containermanager.dylib
       0x1999d6000 -        0x1999e7fff  com.apple.IOSurface (289.3 - 289.3) <9FF9A9E1-CEE6-3B60-B906-9F841A8C458F> /System/Library/Frameworks/IOSurface.framework/Versions/A/IOSurface
       0x1999e8000 -        0x1999f1fff  com.apple.IOAccelerator (439.52 - 439.52) <A26D0961-8422-303E-A46E-F8DC600E4F98> /System/Library/PrivateFrameworks/IOAccelerator.framework/Versions/A/IOAccelerator
       0x1999f2000 -        0x199ae8fff  com.apple.Metal (244.32.7 - 244.32.7) <3184F3A5-FDB4-3D75-BA6E-DA1EB8BCF867> /System/Library/Frameworks/Metal.framework/Versions/A/Metal
       0x199ae9000 -        0x199b08fff  com.apple.audio.caulk (1.0 - 70) <3C740EA2-D7BA-31FA-9540-63E5E5F3A0F7> /System/Library/PrivateFrameworks/caulk.framework/Versions/A/caulk
       0x199b09000 -        0x199bfffff  com.apple.CoreMedia (1.0 - 2760.6.4.6) <5F17C1F2-DF73-3C8A-B049-E270941A1196> /System/Library/Frameworks/CoreMedia.framework/Versions/A/CoreMedia
       0x199c00000 -        0x199d58fff  libFontParser.dylib (305.2.0.6) <C3FF494B-E873-3E1C-9481-60A5D00A12E3> /System/Library/PrivateFrameworks/FontServices.framework/libFontParser.dylib
       0x199d59000 -        0x19a068fff  com.apple.HIToolbox (2.1.1 - 1060.4) <5D42A3EB-F109-386B-BA75-5F72E264A3B9> /System/Library/Frameworks/Carbon.framework/Versions/A/Frameworks/HIToolbox.framework/Versions/A/HIToolbox
       0x19a069000 -        0x19a080fff  com.apple.framework.DFRFoundation (1.0 - 265) <6F86CE64-F282-3F37-BCE4-9E5A38449A9D> /System/Library/PrivateFrameworks/DFRFoundation.framework/Versions/A/DFRFoundation
       0x19a081000 -        0x19a084fff  com.apple.dt.XCTTargetBootstrap (1.0 - 17500) <AE6F2D6D-A031-3F81-B05A-0B67AD3F502D> /System/Library/PrivateFrameworks/XCTTargetBootstrap.framework/Versions/A/XCTTargetBootstrap
       0x19a085000 -        0x19a0affff  com.apple.CoreSVG (1.0 - 149) <5FD325DB-4A8C-32E2-B1B6-FAB9C8DD2DCC> /System/Library/PrivateFrameworks/CoreSVG.framework/Versions/A/CoreSVG
       0x19a0b0000 -        0x19a2cdfff  com.apple.ImageIO (3.3.0 - 2130.2.7) <3B7DCBB0-0493-3818-A156-ACCB65E66323> /System/Library/Frameworks/ImageIO.framework/Versions/A/ImageIO
       0x19a2ce000 -        0x19a5eefff  com.apple.CoreImage (16.1.0 - 1120.10) <8CC24666-D076-36FD-91F1-C083087D5D51> /System/Library/Frameworks/CoreImage.framework/Versions/A/CoreImage
       0x19a5ef000 -        0x19a646fff  com.apple.MetalPerformanceShaders.MPSCore (1.0 - 1) <CF0159EB-938F-3F20-AF71-D8DFB502D71A> /System/Library/Frameworks/MetalPerformanceShaders.framework/Versions/A/Frameworks/MPSCore.framework/Versions/A/MPSCore
       0x19a647000 -        0x19a64bfff  libsystem_configuration.dylib (1109.60.2) <5D4DB975-F8DC-3B07-8F2B-4054CCA4B9B6> /usr/lib/system/libsystem_configuration.dylib
       0x19a64c000 -        0x19a650fff  libsystem_sandbox.dylib (1441.60.4) <0EE4CE47-4715-3EE3-93CA-F4863FE29A5C> /usr/lib/system/libsystem_sandbox.dylib
       0x19a651000 -        0x19a652fff  com.apple.AggregateDictionary (1.0 - 1) <38AB1AE3-0555-343B-85BB-AE9E529D9E91> /System/Library/PrivateFrameworks/AggregateDictionary.framework/Versions/A/AggregateDictionary
       0x19a653000 -        0x19a656fff  com.apple.AppleSystemInfo (3.1.5 - 3.1.5) <4E760B95-F152-3D6C-A879-941D7F7046F3> /System/Library/PrivateFrameworks/AppleSystemInfo.framework/Versions/A/AppleSystemInfo
       0x19a657000 -        0x19a658fff  liblangid.dylib (136) <9BC69285-920A-3469-BDCC-3EE821704AE0> /usr/lib/liblangid.dylib
       0x19a659000 -        0x19a6e7fff  com.apple.CoreNLP (1.0 - 245) <1015A6D8-5D99-3CB3-AC48-55F053134704> /System/Library/PrivateFrameworks/CoreNLP.framework/Versions/A/CoreNLP
       0x19a6e8000 -        0x19a6effff  com.apple.LinguisticData (1.0 - 399) <0C2C6A0B-352B-3A10-9A64-7A467BC0619F> /System/Library/PrivateFrameworks/LinguisticData.framework/Versions/A/LinguisticData
       0x19a6f0000 -        0x19aba4fff  libBNNS.dylib (288.60.2) <A4896748-ACA6-3491-842E-59A6E1A386DF> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libBNNS.dylib
       0x19aba5000 -        0x19ac57fff  libvDSP.dylib (760.40.6) <C9471CC1-5622-390D-A38A-F730A17924C4> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libvDSP.dylib
       0x19ac58000 -        0x19ac6afff  com.apple.CoreEmoji (1.0 - 128) <4790C8CE-AD87-3F74-9721-4A3F931E6B5D> /System/Library/PrivateFrameworks/CoreEmoji.framework/Versions/A/CoreEmoji
       0x19ac6b000 -        0x19ac75fff  com.apple.IOMobileFramebuffer (343.0.0 - 343.0.0) <761968D8-6440-381D-AA1E-A01B10F5766E> /System/Library/PrivateFrameworks/IOMobileFramebuffer.framework/Versions/A/IOMobileFramebuffer
       0x19ac76000 -        0x19ad41fff  com.apple.framework.CoreWLAN (16.0 - 1657) <CA1BD1AF-D57A-3B06-97B1-0AC71F439685> /System/Library/Frameworks/CoreWLAN.framework/Versions/A/CoreWLAN
       0x19ad42000 -        0x19af41fff  com.apple.CoreUtils (6.5 - 650.5) <6A28B5ED-404A-3179-8B43-D1210BDEB176> /System/Library/PrivateFrameworks/CoreUtils.framework/Versions/A/CoreUtils
       0x19af42000 -        0x19af64fff  com.apple.MobileKeyBag (2.0 - 1.0) <E5430E72-A4F5-3E0E-80FE-D18010F58F6E> /System/Library/PrivateFrameworks/MobileKeyBag.framework/Versions/A/MobileKeyBag
       0x19af65000 -        0x19af74fff  com.apple.AssertionServices (1.0 - 505.60.2) <1CD9B6A5-00E1-3A26-A389-E1D93B077876> /System/Library/PrivateFrameworks/AssertionServices.framework/Versions/A/AssertionServices
       0x19af75000 -        0x19affafff  com.apple.securityfoundation (6.0 - 55240.40.4) <B74FE7B0-C339-3483-95F8-B219820F5540> /System/Library/Frameworks/SecurityFoundation.framework/Versions/A/SecurityFoundation
       0x19affb000 -        0x19b004fff  com.apple.coreservices.BackgroundTaskManagement (1.0 - 104) <42AFCFE1-F6F3-30D4-A278-FF43847F5733> /System/Library/PrivateFrameworks/BackgroundTaskManagement.framework/Versions/A/BackgroundTaskManagement
       0x19b005000 -        0x19b00afff  com.apple.xpc.ServiceManagement (1.0 - 1) <F21342A9-E6E0-3535-B40B-96E62A27ADA3> /System/Library/Frameworks/ServiceManagement.framework/Versions/A/ServiceManagement
       0x19b00b000 -        0x19b00dfff  libquarantine.dylib (119.40.2) <C55DCBDE-51FF-3D90-AF78-9BE9F8FC8DD6> /usr/lib/system/libquarantine.dylib
       0x19b00e000 -        0x19b01dfff  libCheckFix.dylib (31) <A9A06358-3C31-30B8-89BF-02C7274E686B> /usr/lib/libCheckFix.dylib
       0x19b01e000 -        0x19b034fff  libcoretls.dylib (169) <CBE8AF33-CAFF-36F8-B36A-B8F3ACCC0D05> /usr/lib/libcoretls.dylib
       0x19b035000 -        0x19b045fff  libbsm.0.dylib (68.40.1) <A42FE2FA-6D61-3A6B-BC18-D81CF9EEC26E> /usr/lib/libbsm.0.dylib
       0x19b046000 -        0x19b08afff  libmecab.dylib (929.1.1) <022FB4B7-EDB7-3637-9E32-57EDF231EFBD> /usr/lib/libmecab.dylib
       0x19b08b000 -        0x19b08ffff  libgermantok.dylib (24) <DAD2668B-A6FD-34C9-8AEE-A2CFBD4305B9> /usr/lib/libgermantok.dylib
       0x19b090000 -        0x19b0a5fff  libLinearAlgebra.dylib (1336.40.1) <EF07960C-DBF1-34A0-9F03-E8969D4BA4E8> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libLinearAlgebra.dylib
       0x19b0a6000 -        0x19b2a9fff  com.apple.MetalPerformanceShaders.MPSNeuralNetwork (1.0 - 1) <4193E38D-0646-36C8-AD8B-E5F22A68846D> /System/Library/Frameworks/MetalPerformanceShaders.framework/Versions/A/Frameworks/MPSNeuralNetwork.framework/Versions/A/MPSNeuralNetwork
       0x19b2aa000 -        0x19b2f3fff  com.apple.MetalPerformanceShaders.MPSRayIntersector (1.0 - 1) <B27589D3-909F-3C86-8597-762ED8052082> /System/Library/Frameworks/MetalPerformanceShaders.framework/Versions/A/Frameworks/MPSRayIntersector.framework/Versions/A/MPSRayIntersector
       0x19b2f4000 -        0x19b42efff  com.apple.MLCompute (1.0 - 1) <CD745414-6E80-3BCD-9EFE-CE192AC0AEB4> /System/Library/Frameworks/MLCompute.framework/Versions/A/MLCompute
       0x19b42f000 -        0x19b45dfff  com.apple.MetalPerformanceShaders.MPSMatrix (1.0 - 1) <5867536B-0869-3ED4-AB5D-60E0FD9BFE70> /System/Library/Frameworks/MetalPerformanceShaders.framework/Versions/A/Frameworks/MPSMatrix.framework/Versions/A/MPSMatrix
       0x19b45e000 -        0x19b499fff  com.apple.MetalPerformanceShaders.MPSNDArray (1.0 - 1) <08BD5CCA-0485-3C1F-A3E0-5C1A2058E533> /System/Library/Frameworks/MetalPerformanceShaders.framework/Versions/A/Frameworks/MPSNDArray.framework/Versions/A/MPSNDArray
       0x19b49a000 -        0x19b524fff  com.apple.MetalPerformanceShaders.MPSImage (1.0 - 1) <24F9DB17-EB5E-3AA9-A15C-B0DBCC5A8991> /System/Library/Frameworks/MetalPerformanceShaders.framework/Versions/A/Frameworks/MPSImage.framework/Versions/A/MPSImage
       0x19b525000 -        0x19b534fff  com.apple.AppleFSCompression (125 - 1.0) <D5F93E39-B11F-3862-93CD-BB162E078EB9> /System/Library/PrivateFrameworks/AppleFSCompression.framework/Versions/A/AppleFSCompression
       0x19b535000 -        0x19b541fff  libbz2.1.0.dylib (44) <78DA9846-BC91-3FEF-BCAE-DA445E2F4007> /usr/lib/libbz2.1.0.dylib
       0x19b542000 -        0x19b546fff  libsystem_coreservices.dylib (127) <1F4E0C2D-9A82-3E3F-B546-1F23A3B180B5> /usr/lib/system/libsystem_coreservices.dylib
       0x19b547000 -        0x19b577fff  com.apple.CoreServices.OSServices (1122.11 - 1122.11) <EFFA0C4E-A0C1-3970-BE40-A0A46A35C180> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/OSServices.framework/Versions/A/OSServices
       0x19b578000 -        0x19b68dfff  com.apple.AuthKit (1.0 - 1) <6C08E7C4-862E-36F7-B8B0-6A7BC9B010AA> /System/Library/PrivateFrameworks/AuthKit.framework/Versions/A/AuthKit
       0x19b735000 -        0x19b746fff  libz.1.dylib (76) <5EA0F5F6-7974-3DF8-9862-CE916C5EC980> /usr/lib/libz.1.dylib
       0x19b747000 -        0x19b774fff  libsystem_m.dylib (3186.40.2) <129930A8-F06B-3AD4-BA84-21549591F87A> /usr/lib/system/libsystem_m.dylib
       0x19b775000 -        0x19b775fff  libcharset.1.dylib (59) <DF7E5E0B-8534-3D78-96D4-519E0F22DD02> /usr/lib/libcharset.1.dylib
       0x19b776000 -        0x19b77bfff  libmacho.dylib (973.4) <29AD4E0E-F6A4-313F-AFA3-825CA94917BD> /usr/lib/system/libmacho.dylib
       0x19b77c000 -        0x19b797fff  libkxld.dylib (7195.60.75) <8BEBE228-8A15-383D-8E30-A20B2E2082B5> /usr/lib/system/libkxld.dylib
       0x19b798000 -        0x19b7a5fff  libcommonCrypto.dylib (60178.40.2) <FEDF1785-B89A-3EFB-B95E-467645AC6113> /usr/lib/system/libcommonCrypto.dylib
       0x19b7a6000 -        0x19b7b0fff  libunwind.dylib (200.10) <21A28401-C508-38BE-A7CF-C2A56AB3C311> /usr/lib/system/libunwind.dylib
       0x19b7b1000 -        0x19b7b8fff  liboah.dylib (203.13.2) <F36DDACF-B46B-3813-8ADE-A275209588BF> /usr/lib/liboah.dylib
       0x19b7b9000 -        0x19b7c1fff  libcopyfile.dylib (173.40.2) <8AE5EFE8-BBA5-380B-9165-D350CD7EA3CE> /usr/lib/system/libcopyfile.dylib
       0x19b7c2000 -        0x19b7c5fff  libcompiler_rt.dylib (102.2) <39A3467E-CBED-3C4A-B0BC-39C0093842E9> /usr/lib/system/libcompiler_rt.dylib
       0x19b7c6000 -        0x19b7c8fff  libsystem_collections.dylib (1439.40.11) <5EEC397D-2CAA-39D1-8B82-6370E633FDC9> /usr/lib/system/libsystem_collections.dylib
       0x19b7c9000 -        0x19b7cbfff  libsystem_secinit.dylib (87.60.1) <04EF7D20-ABBD-3DB1-B990-278887044735> /usr/lib/system/libsystem_secinit.dylib
       0x19b7cc000 -        0x19b7cefff  libremovefile.dylib (49.40.3) <8FAF9121-D546-3319-B366-1C50BAF59FE8> /usr/lib/system/libremovefile.dylib
       0x19b7cf000 -        0x19b7cffff  libkeymgr.dylib (31) <3EF55D83-6DD4-376B-8C0B-5B12CD0D3D94> /usr/lib/system/libkeymgr.dylib
       0x19b7d0000 -        0x19b7d8fff  libsystem_dnssd.dylib (1310.60.4) <E498E2D5-BD16-3458-AF9C-B4EE888935CB> /usr/lib/system/libsystem_dnssd.dylib
       0x19b7d9000 -        0x19b7defff  libcache.dylib (83) <BF1D536B-540F-374E-BA7B-EB2429F334CD> /usr/lib/system/libcache.dylib
       0x19b7df000 -        0x19b7e0fff  libSystem.B.dylib (1292.60.1) <03EDCD03-5B2F-353E-BD06-6313B8279E9C> /usr/lib/libSystem.B.dylib
       0x19b7e1000 -        0x19b7e4fff  libfakelink.dylib (3) <B5AF719C-EC9A-3714-9E29-65FA0920BFE4> /usr/lib/libfakelink.dylib
       0x19b7e5000 -        0x19b7e5fff  com.apple.SoftLinking (1.0 - 1) <DD7C1F9C-6512-35D2-9391-450628D67E19> /System/Library/PrivateFrameworks/SoftLinking.framework/Versions/A/SoftLinking
       0x19b7e6000 -        0x19b820fff  libpcap.A.dylib (98.40.1) <8056A56E-73C0-36F1-849E-262FD7C33550> /usr/lib/libpcap.A.dylib
       0x19b821000 -        0x19b913fff  libiconv.2.dylib (59) <B745BF03-D15C-3B71-9774-894201EC76CF> /usr/lib/libiconv.2.dylib
       0x19b914000 -        0x19b929fff  libcmph.dylib (8) <1B539AD1-EB4E-3E4E-9936-A8FF9F3D65B9> /usr/lib/libcmph.dylib
       0x19b92a000 -        0x19b99afff  libarchive.2.dylib (83.40.4) <5CBBFEF0-AE9F-3967-B916-68EEC897969D> /usr/lib/libarchive.2.dylib
       0x19b99b000 -        0x19ba0bfff  com.apple.SearchKit (1.4.1 - 1.4.1) <7A1F87D4-B5D2-3F0D-B732-FA696B45B882> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/SearchKit.framework/Versions/A/SearchKit
       0x19ba0c000 -        0x19ba0dfff  libThaiTokenizer.dylib (3) <74A6D3FA-8A99-3303-9A8B-26620CC232AE> /usr/lib/libThaiTokenizer.dylib
       0x19ba0e000 -        0x19ba32fff  com.apple.applesauce (1.0 - 16.26) <F38BC353-F9A4-3762-AEF4-DA4692FE80B6> /System/Library/PrivateFrameworks/AppleSauce.framework/Versions/A/AppleSauce
       0x19ba33000 -        0x19ba49fff  libapple_nghttp2.dylib (1.41) <7ABA6797-C912-3F49-BCA5-2405D30BEAF9> /usr/lib/libapple_nghttp2.dylib
       0x19ba4a000 -        0x19ba5bfff  libSparseBLAS.dylib (1336.40.1) <147B4C34-5369-39C6-99A3-559800DB28A5> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libSparseBLAS.dylib
       0x19ba5c000 -        0x19ba5dfff  com.apple.MetalPerformanceShaders.MetalPerformanceShaders (1.0 - 1) <B22701AF-CE19-3635-AF1D-FB69EB0E6A7C> /System/Library/Frameworks/MetalPerformanceShaders.framework/Versions/A/MetalPerformanceShaders
       0x19ba5e000 -        0x19ba62fff  libpam.2.dylib (28.40.1) <0BFA77F1-A62A-356C-B901-3D158E1B7E95> /usr/lib/libpam.2.dylib
       0x19ba63000 -        0x19ba7afff  libcompression.dylib (96.40.6) <A01701F6-D89C-3E89-B429-79DB81426F12> /usr/lib/libcompression.dylib
       0x19ba7b000 -        0x19ba7ffff  libQuadrature.dylib (7) <B2DD0691-70A9-3EE4-A5DC-D2FFFE71ECC5> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libQuadrature.dylib
       0x19ba80000 -        0x19bf2afff  libLAPACK.dylib (1336.40.1) <E94DE514-61CA-3C60-B3D7-C9257223FDA5> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libLAPACK.dylib
       0x19bf2b000 -        0x19bf7cfff  com.apple.DictionaryServices (1.2 - 341) <0B2A9791-DAE5-3D19-B10E-834F807455DE> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/DictionaryServices.framework/Versions/A/DictionaryServices
       0x19bf7d000 -        0x19bf95fff  liblzma.5.dylib (16) <2F09739A-498C-39D9-823E-BA62312F540E> /usr/lib/liblzma.5.dylib
       0x19bf96000 -        0x19bf97fff  libcoretls_cfhelpers.dylib (169) <15F18276-CC9C-3822-97F0-0C5B6F33B145> /usr/lib/libcoretls_cfhelpers.dylib
       0x19bf98000 -        0x19c07efff  com.apple.APFS (1677.60.23 - 1677.60.23) <39013AA0-2845-349F-A323-9D7BC3B74C2D> /System/Library/PrivateFrameworks/APFS.framework/Versions/A/APFS
       0x19c07f000 -        0x19c08cfff  libxar.1.dylib (452) <01CD3C4E-C3F8-3CDB-B4CF-2F59B236C0B9> /usr/lib/libxar.1.dylib
       0x19c08d000 -        0x19c090fff  libutil.dylib (58.40.2) <857F5F7E-6554-3F68-AC00-B2F2E43B4249> /usr/lib/libutil.dylib
       0x19c091000 -        0x19c0bafff  libxslt.1.dylib (17.2) <AAC88056-759F-32E3-8388-D9FF2EB55B61> /usr/lib/libxslt.1.dylib
       0x19c0bb000 -        0x19c0c5fff  libChineseTokenizer.dylib (37) <F24F3F8F-9D4A-38BD-951E-8C9F19037DBB> /usr/lib/libChineseTokenizer.dylib
       0x19c0c6000 -        0x19c13afff  libvMisc.dylib (760.40.6) <48EB6D40-7B0D-3CB0-9F4D-1481ABB81222> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libvMisc.dylib
       0x19c13b000 -        0x19c1ccfff  libate.dylib (3.0.4) <942482F9-681B-3238-9849-D9C02457D978> /usr/lib/libate.dylib
       0x19c1cd000 -        0x19c1d4fff  libIOReport.dylib (64) <A7FF0874-7F11-3BEC-A602-1E85F832832B> /usr/lib/libIOReport.dylib
       0x19c1d5000 -        0x19c201fff  com.apple.CrashReporterSupport (10.13 - 15047) <10E95DD9-8005-3495-93C0-6A0FB36A97E5> /System/Library/PrivateFrameworks/CrashReporterSupport.framework/Versions/A/CrashReporterSupport
       0x19c2e8000 -        0x19c2effff  libMatch.1.dylib (38) <373E5F26-615E-356B-AC28-70EA9204AF22> /usr/lib/libMatch.1.dylib
       0x19c2f0000 -        0x19c373fff  libCoreStorage.dylib (554) <7C857783-8F9D-3ED6-9234-47E608A2DDD0> /usr/lib/libCoreStorage.dylib
       0x19c374000 -        0x19c3bffff  com.apple.AppleVAFramework (6.1.3 - 6.1.3) <AB0B7ABC-9FD1-3476-A16A-35F6501D1540> /System/Library/PrivateFrameworks/AppleVA.framework/Versions/A/AppleVA
       0x19c3c0000 -        0x19c3d9fff  libexpat.1.dylib (26) <8B917E86-B3FC-3B18-9DD2-4D157E77320B> /usr/lib/libexpat.1.dylib
       0x19c3da000 -        0x19c3e3fff  libheimdal-asn1.dylib (597.40.10) <08B0980A-F6E1-3B41-81D5-8C4A7566F55D> /usr/lib/libheimdal-asn1.dylib
       0x19c3e4000 -        0x19c3f6fff  com.apple.IconFoundation (479.3 - 479.3) <D62CCE4A-04DE-3DC9-92A1-B6196B3891E8> /System/Library/PrivateFrameworks/IconFoundation.framework/Versions/A/IconFoundation
       0x19c3f7000 -        0x19c45dfff  com.apple.IconServices (479.3 - 479.3) <FC2A8690-F2D4-3EA3-869C-E685C2BCE873> /System/Library/PrivateFrameworks/IconServices.framework/Versions/A/IconServices
       0x19c45e000 -        0x19c501fff  com.apple.MediaExperience (1.0 - 1) <F794A130-19C3-34F4-8678-016A36509465> /System/Library/PrivateFrameworks/MediaExperience.framework/Versions/A/MediaExperience
       0x19c502000 -        0x19c528fff  com.apple.persistentconnection (1.0 - 1.0) <D423D474-AB61-3F4E-9508-ED25B9E12012> /System/Library/PrivateFrameworks/PersistentConnection.framework/Versions/A/PersistentConnection
       0x19c529000 -        0x19c536fff  com.apple.GraphVisualizer (1.0 - 100.1) <4C8E4148-A718-392A-B617-787534895649> /System/Library/PrivateFrameworks/GraphVisualizer.framework/Versions/A/GraphVisualizer
       0x19c537000 -        0x19c949fff  com.apple.vision.FaceCore (4.3.2 - 4.3.2) <E5805F32-080F-3690-9D51-918C266A3E8E> /System/Library/PrivateFrameworks/FaceCore.framework/Versions/A/FaceCore
       0x19c94a000 -        0x19c98bfff  com.apple.OTSVG (1.0 - 677.2.0.5) <7850AA94-4208-3CF7-8CC0-4889F36AB01D> /System/Library/PrivateFrameworks/OTSVG.framework/Versions/A/OTSVG
       0x19c98c000 -        0x19c993fff  com.apple.xpc.AppServerSupport (1.0 - 2038.40.38) <911AB008-23FE-3134-B433-0321073F0BDC> /System/Library/PrivateFrameworks/AppServerSupport.framework/Versions/A/AppServerSupport
       0x19c994000 -        0x19c9a2fff  libhvf.dylib (1.0 - $[CURRENT_PROJECT_VERSION]) <145974E6-1A9C-3481-A55E-529E84F0CD94> /System/Library/PrivateFrameworks/FontServices.framework/libhvf.dylib
       0x19c9a3000 -        0x19c9a5fff  libspindump.dylib (295) <52B9391B-7757-3A44-B435-E8A640F3B505> /usr/lib/libspindump.dylib
       0x19c9a6000 -        0x19ca5afff  com.apple.Heimdal (4.0 - 2.0) <8B0D70D0-3C4C-3A1E-B55C-C2F2AF0C5F32> /System/Library/PrivateFrameworks/Heimdal.framework/Versions/A/Heimdal
       0x19ca5b000 -        0x19ca75fff  com.apple.login (3.0 - 3.0) <E74E590C-66D8-303D-9162-976BFFA449A0> /System/Library/PrivateFrameworks/login.framework/Versions/A/login
       0x19cbed000 -        0x19cc4cfff  com.apple.bom (14.0 - 233) <DCDA5BE2-828A-3CC7-8801-8E0ECDF3DCE4> /System/Library/PrivateFrameworks/Bom.framework/Versions/A/Bom
       0x19cc4d000 -        0x19cc90fff  com.apple.AppleJPEG (1.0 - 1) <1FC15817-A4AF-39EC-83DB-7EF49DCC49EE> /System/Library/PrivateFrameworks/AppleJPEG.framework/Versions/A/AppleJPEG
       0x19cc91000 -        0x19cd75fff  libJP2.dylib (2130.2.7) <D8C55474-A9B6-3B5E-A7BC-98CC57204F7C> /System/Library/Frameworks/ImageIO.framework/Versions/A/Resources/libJP2.dylib
       0x19cd76000 -        0x19cd79fff  com.apple.WatchdogClient.framework (1.0 - 98.60.1) <E800B674-7E5F-36DB-8461-E0B08D3F8594> /System/Library/PrivateFrameworks/WatchdogClient.framework/Versions/A/WatchdogClient
       0x19cd7a000 -        0x19cdaefff  com.apple.MultitouchSupport.framework (4400.28 - 4400.28) <79604DF8-4953-3B82-B118-7D4797A5E1BD> /System/Library/PrivateFrameworks/MultitouchSupport.framework/Versions/A/MultitouchSupport
       0x19cdaf000 -        0x19ced4fff  com.apple.VideoToolbox (1.0 - 2760.6.4.6) <7225282B-0656-37B2-8A61-DC1D4B005000> /System/Library/Frameworks/VideoToolbox.framework/Versions/A/VideoToolbox
       0x19ced5000 -        0x19cf07fff  libAudioToolboxUtility.dylib (1180.23) <7AE3473A-AC33-34E8-B2A1-28CBB86BD302> /usr/lib/libAudioToolboxUtility.dylib
       0x19cf08000 -        0x19cf2efff  libPng.dylib (2130.2.7) <7E71956F-03EA-383D-A481-C5F233865CD7> /System/Library/Frameworks/ImageIO.framework/Versions/A/Resources/libPng.dylib
       0x19cf2f000 -        0x19cf89fff  libTIFF.dylib (2130.2.7) <725BCDFF-8637-3FFC-93D1-FCA7E0C2CE4A> /System/Library/Frameworks/ImageIO.framework/Versions/A/Resources/libTIFF.dylib
       0x19cf8a000 -        0x19cfa6fff  com.apple.IOPresentment (53 - 37) <F4CC2ABF-FAAD-3F34-9CB9-A012C9C1E387> /System/Library/PrivateFrameworks/IOPresentment.framework/Versions/A/IOPresentment
       0x19cfa7000 -        0x19cfabfff  com.apple.GPUWrangler (6.2.2 - 6.2.2) <FD5B24DE-DFDE-3FCE-AED6-6C49C0FD12A9> /System/Library/PrivateFrameworks/GPUWrangler.framework/Versions/A/GPUWrangler
       0x19cfac000 -        0x19cfaefff  libRadiance.dylib (2130.2.7) <635C3E69-E2B0-31E3-B004-A5FF0F5E9A7B> /System/Library/Frameworks/ImageIO.framework/Versions/A/Resources/libRadiance.dylib
       0x19cfaf000 -        0x19cfb4fff  com.apple.DSExternalDisplay (3.1 - 380) <56A2B5E6-B0B0-3F89-AD12-9EC961231366> /System/Library/PrivateFrameworks/DSExternalDisplay.framework/Versions/A/DSExternalDisplay
       0x19cfb5000 -        0x19cfd5fff  libJPEG.dylib (2130.2.7) <7E5DE231-8044-311C-AB96-788C1AA406CA> /System/Library/Frameworks/ImageIO.framework/Versions/A/Resources/libJPEG.dylib
       0x19cfd6000 -        0x19d005fff  com.apple.ATSUI (1.0 - 1) <9E776419-229D-30CC-AD40-193F29B2C670> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ATSUI.framework/Versions/A/ATSUI
       0x19d006000 -        0x19d00afff  libGIF.dylib (2130.2.7) <127658D4-6452-38A2-808E-161086C94C47> /System/Library/Frameworks/ImageIO.framework/Versions/A/Resources/libGIF.dylib
       0x19d00b000 -        0x19d014fff  com.apple.CMCaptureCore (1.0 - 80.17.1.1) <A89879A4-F679-3168-A50A-8F83FBE3184C> /System/Library/PrivateFrameworks/CMCaptureCore.framework/Versions/A/CMCaptureCore
       0x19d015000 -        0x19d05cfff  com.apple.print.framework.PrintCore (16 - 531) <456F8F80-DDEC-397C-B43C-EE799ECDA3F7> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/PrintCore.framework/Versions/A/PrintCore
       0x19d05d000 -        0x19d111fff  com.apple.TextureIO (3.10.9 - 3.10.9) <D54C961C-800D-3309-8E90-1EB8EF470CD9> /System/Library/PrivateFrameworks/TextureIO.framework/Versions/A/TextureIO
       0x19d112000 -        0x19d11afff  com.apple.InternationalSupport (1.0 - 60) <55754151-4F79-342F-8D91-53A16E9E83B8> /System/Library/PrivateFrameworks/InternationalSupport.framework/Versions/A/InternationalSupport
       0x19d11b000 -        0x19d18ffff  com.apple.datadetectorscore (8.0 - 674) <44607BEB-812C-3152-AFE6-51C960D15D12> /System/Library/PrivateFrameworks/DataDetectorsCore.framework/Versions/A/DataDetectorsCore
       0x19d190000 -        0x19d1f0fff  com.apple.UserActivity (435 - 435) <33EC085E-4106-3662-9FBE-6D3687ABFF34> /System/Library/PrivateFrameworks/UserActivity.framework/Versions/A/UserActivity
       0x19de8d000 -        0x19dec2fff  libSessionUtility.dylib (76.7) <55B76612-B425-3BC5-B828-900FE52745A3> /System/Library/PrivateFrameworks/AudioSession.framework/libSessionUtility.dylib
       0x19dec3000 -        0x19dfe7fff  com.apple.audio.toolbox.AudioToolbox (1.14 - 1.14) <2A0EA878-17A0-3D13-9FE0-D3AB09DD5187> /System/Library/Frameworks/AudioToolbox.framework/Versions/A/AudioToolbox
       0x19dfe8000 -        0x19e051fff  com.apple.audio.AudioSession (1.0 - 76.7) <BDC23BAB-CFE3-32DB-B8AF-C240056C6DF3> /System/Library/PrivateFrameworks/AudioSession.framework/Versions/A/AudioSession
       0x19e052000 -        0x19e064fff  libAudioStatistics.dylib (25.1) <E02FB648-3DFA-349C-9F5C-FECCF8E99A1C> /usr/lib/libAudioStatistics.dylib
       0x19e065000 -        0x19e078fff  com.apple.speech.synthesis.framework (9.0.51 - 9.0.51) <2205CF41-DFC6-325B-B2A7-EBB0DD2F73BE> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/SpeechSynthesis.framework/Versions/A/SpeechSynthesis
       0x19e079000 -        0x19e0e6fff  com.apple.ApplicationServices.ATS (377 - 516) <D4C1DA84-5F74-3CB6-97A9-46C6E91BA974> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ATS.framework/Versions/A/ATS
       0x19e0e7000 -        0x19e0fffff  libresolv.9.dylib (68) <62492883-5FA7-39E0-ADED-F0788266FFD2> /usr/lib/libresolv.9.dylib
       0x19e227000 -        0x19e306fff  libSMC.dylib (20) <10AD3F44-AD41-3294-A9B0-3AF86ADF456C> /usr/lib/libSMC.dylib
       0x19e307000 -        0x19e367fff  libcups.2.dylib (494.1) <C2CD4DBE-13B4-3D93-902B-D88C4B60A628> /usr/lib/libcups.2.dylib
       0x19e368000 -        0x19e377fff  com.apple.LangAnalysis (1.7.0 - 254) <10918D61-B681-339C-A380-89F3B66D7232> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/LangAnalysis.framework/Versions/A/LangAnalysis
       0x19e378000 -        0x19e384fff  com.apple.NetAuth (6.2 - 6.2) <06B8BA21-FA96-377F-89ED-56B6FBB54193> /System/Library/PrivateFrameworks/NetAuth.framework/Versions/A/NetAuth
       0x19e385000 -        0x19e38cfff  com.apple.ColorSyncLegacy (4.13.0 - 1) <B7489608-9E2E-32D3-A745-DB1FFDF85600> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ColorSyncLegacy.framework/Versions/A/ColorSyncLegacy
       0x19e38d000 -        0x19e398fff  com.apple.QD (4.0 - 416) <B1EE6F13-A80F-3DED-AE1B-DAEEB0FD7F2A> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/QD.framework/Versions/A/QD
       0x19e399000 -        0x19e99ffff  com.apple.audio.AudioResourceArbitration (1.0 - 1) <7D03969A-C2B0-30C9-AAAD-F530C2777D77> /System/Library/PrivateFrameworks/AudioResourceArbitration.framework/Versions/A/AudioResourceArbitration
       0x19e9a0000 -        0x19e9abfff  com.apple.perfdata (1.0 - 67.40.1) <E6DD9E16-3FDF-36F7-AB71-6193DFD7A2C2> /System/Library/PrivateFrameworks/perfdata.framework/Versions/A/perfdata
       0x19e9ac000 -        0x19e9bafff  libperfcheck.dylib (41) <FFAF5096-29A0-32D7-9503-330BE86BA903> /usr/lib/libperfcheck.dylib
       0x19e9bb000 -        0x19e9cbfff  com.apple.Kerberos (3.0 - 1) <228A8531-187C-3222-A570-2AC0F24A1ECE> /System/Library/Frameworks/Kerberos.framework/Versions/A/Kerberos
       0x19e9cc000 -        0x19ea14fff  com.apple.GSS (4.0 - 2.0) <6A6552F1-C125-3404-8984-7B40C0579C14> /System/Library/Frameworks/GSS.framework/Versions/A/GSS
       0x19ea15000 -        0x19ea24fff  com.apple.CommonAuth (4.0 - 2.0) <40640305-7C1A-3E9F-B304-38376416EEA4> /System/Library/PrivateFrameworks/CommonAuth.framework/Versions/A/CommonAuth
       0x19ea79000 -        0x19ea9afff  com.apple.security.KeychainCircle.KeychainCircle (1.0 - 1) <4AA42633-FA6B-3029-9373-3C791C2AA7BC> /System/Library/PrivateFrameworks/KeychainCircle.framework/Versions/A/KeychainCircle
       0x19ea9b000 -        0x19eaa3fff  com.apple.CorePhoneNumbers (1.0 - 1) <1D5F5EF2-789C-36F5-A115-BB140EEBBF59> /System/Library/PrivateFrameworks/CorePhoneNumbers.framework/Versions/A/CorePhoneNumbers
       0x19ebf1000 -        0x19ebf1fff  liblaunch.dylib (2038.40.38) <A42FB952-AEBC-335F-8336-751E963F09F4> /usr/lib/system/liblaunch.dylib
       0x19f3c6000 -        0x19f503fff  com.apple.Sharing (1575 - 1575) <41777B8B-4817-3B84-9EDF-8BEE1E717456> /System/Library/PrivateFrameworks/Sharing.framework/Versions/A/Sharing
       0x19f504000 -        0x19f5fbfff  com.apple.Bluetooth (8.0.2 - 8.0.2f9) <747DC141-C975-30BC-98E0-CB43EF17018C> /System/Library/Frameworks/IOBluetooth.framework/Versions/A/IOBluetooth
       0x19f5fc000 -        0x19f60ffff  com.apple.AppContainer (4.0 - 509.60.2) <278D1395-238B-31CD-A636-30B1F7D0CFF1> /System/Library/PrivateFrameworks/AppContainer.framework/Versions/A/AppContainer
       0x19f610000 -        0x19f613fff  com.apple.SecCodeWrapper (4.0 - 509.60.2) <1062A2DA-BEA8-3C8F-A008-A30AF251489D> /System/Library/PrivateFrameworks/SecCodeWrapper.framework/Versions/A/SecCodeWrapper
       0x19f614000 -        0x19f66cfff  com.apple.ProtectedCloudStorage (1.0 - 1) <C2875C59-B7D4-360A-A2AF-4CE27686AE90> /System/Library/PrivateFrameworks/ProtectedCloudStorage.framework/Versions/A/ProtectedCloudStorage
       0x19f6cd000 -        0x19f6e9fff  com.apple.MetalKit (147.1 - 147.1) <2DE23F83-D3CA-361E-BCD3-DC633B9C6FBC> /System/Library/Frameworks/MetalKit.framework/Versions/A/MetalKit
       0x1a0e34000 -        0x1a0e5bfff  com.apple.RemoteViewServices (2.0 - 163) <351E4523-E99A-3849-88A1-96072B599D5C> /System/Library/PrivateFrameworks/RemoteViewServices.framework/Versions/A/RemoteViewServices
       0x1a0e5c000 -        0x1a0e6bfff  com.apple.SpeechRecognitionCore (6.1.12 - 6.1.12) <D692FAF5-0245-3883-8DF3-7655E881BF00> /System/Library/PrivateFrameworks/SpeechRecognitionCore.framework/Versions/A/SpeechRecognitionCore
       0x1a0e6c000 -        0x1a0e73fff  com.apple.speech.recognition.framework (6.0.3 - 6.0.3) <9DC7A28A-4E40-35EE-83DC-FCE5261B3630> /System/Library/Frameworks/Carbon.framework/Versions/A/Frameworks/SpeechRecognition.framework/Versions/A/SpeechRecognition
       0x1a10b4000 -        0x1a10b4fff  libsystem_product_info_filter.dylib (8.40.1) <BF4F283D-1B0C-3A5A-8DAC-CFB3096CEDB4> /usr/lib/system/libsystem_product_info_filter.dylib
       0x1a118d000 -        0x1a118dfff  com.apple.Accelerate.vecLib (3.11 - vecLib 3.11) <7C0FF713-FC2B-3857-B278-119FF3DC693F> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/vecLib
       0x1a11b4000 -        0x1a11b4fff  com.apple.CoreServices (1122.11 - 1122.11) <797631B9-00AA-354E-8B87-E753665B6CCF> /System/Library/Frameworks/CoreServices.framework/Versions/A/CoreServices
       0x1a146e000 -        0x1a146efff  com.apple.Accelerate (1.11 - Accelerate 1.11) <C114DE30-B4F9-36A6-B7FC-AF43156C4401> /System/Library/Frameworks/Accelerate.framework/Versions/A/Accelerate
       0x1a1d02000 -        0x1a1d5dfff  com.apple.CoreBluetooth (1.0 - 1) <11FE4920-7267-36EB-8B17-151B8F41D654> /System/Library/Frameworks/CoreBluetooth.framework/Versions/A/CoreBluetooth
       0x1a1d5e000 -        0x1a1d68fff  com.apple.SymptomDiagnosticReporter (1.0 - 79.40.12) <9281E634-5ABF-3485-9869-1660C3F2B75D> /System/Library/PrivateFrameworks/SymptomDiagnosticReporter.framework/Versions/A/SymptomDiagnosticReporter
       0x1a1d7e000 -        0x1a1d89fff  com.apple.AppleIDAuthSupport (1.0 - 1) <55DA8399-E764-3464-AA63-FB7DBA1C041B> /System/Library/PrivateFrameworks/AppleIDAuthSupport.framework/Versions/A/AppleIDAuthSupport
       0x1a1d8a000 -        0x1a1e3efff  com.apple.DiscRecording (9.0.3 - 9030.4.5) <F64FFFE7-AB74-3C03-BAFB-BCBF4DBCDBCD> /System/Library/Frameworks/DiscRecording.framework/Versions/A/DiscRecording
       0x1a1e3f000 -        0x1a1e72fff  com.apple.MediaKit (16 - 927.40.2) <AFF2AF6E-FACA-34D1-BA21-F01E445DB697> /System/Library/PrivateFrameworks/MediaKit.framework/Versions/A/MediaKit
       0x1a1e73000 -        0x1a1f53fff  com.apple.DiskManagement (14.0 - 1733.60.1) <E216DF7D-FACF-39C9-B316-9AF2F8F08E04> /System/Library/PrivateFrameworks/DiskManagement.framework/Versions/A/DiskManagement
       0x1a1f94000 -        0x1a20bcfff  com.apple.FileProvider (326 - 326) <41CFE519-0190-3E90-97B3-692046037AE1> /System/Library/Frameworks/FileProvider.framework/Versions/A/FileProvider
       0x1a20bd000 -        0x1a20e0fff  com.apple.GenerationalStorage (2.0 - 322) <7C39E85F-C302-380F-9E7D-EFF873607707> /System/Library/PrivateFrameworks/GenerationalStorage.framework/Versions/A/GenerationalStorage
       0x1a2a7d000 -        0x1a2ab7fff  com.apple.DebugSymbols (195.1 - 195.1) <525D1AB3-CF31-3314-9A19-599D5078FAEF> /System/Library/PrivateFrameworks/DebugSymbols.framework/Versions/A/DebugSymbols
       0x1a2ab8000 -        0x1a2b6ffff  com.apple.CoreSymbolication (12.2 - 64541.4) <DDEA1AAD-5FC1-3C0C-BD5A-ABE12F310473> /System/Library/PrivateFrameworks/CoreSymbolication.framework/Versions/A/CoreSymbolication
       0x1a39f6000 -        0x1a3a55fff  com.apple.framework.Apple80211 (17.0 - 1728) <BE2820B6-286D-3EB7-B219-C0E267335AA3> /System/Library/PrivateFrameworks/Apple80211.framework/Versions/A/Apple80211
       0x1a3a56000 -        0x1a3b8efff  com.apple.CoreWiFi (3.0 - 341) <138EC2D6-6250-3E1C-AC0E-B78B4E5D9802> /System/Library/PrivateFrameworks/CoreWiFi.framework/Versions/A/CoreWiFi
       0x1a3df8000 -        0x1a3e07fff  com.apple.xpc.RemoteServiceDiscovery (1.0 - 2038.40.38) <10757691-CC02-38D3-B5D8-A264D9648519> /System/Library/PrivateFrameworks/RemoteServiceDiscovery.framework/Versions/A/RemoteServiceDiscovery
       0x1a3e08000 -        0x1a3e1ffff  com.apple.xpc.RemoteXPC (1.0 - 2038.40.38) <D62A0803-B9E0-38E6-8D95-E4DEC0E27AEE> /System/Library/PrivateFrameworks/RemoteXPC.framework/Versions/A/RemoteXPC
       0x1a3e67000 -        0x1a3e6efff  com.apple.EFILogin (2.0 - 2) <C454840B-BCC2-300B-99B3-10FCAE76E131> /System/Library/PrivateFrameworks/EFILogin.framework/Versions/A/EFILogin
       0x1a3e6f000 -        0x1a3e7afff  libcsfde.dylib (554) <A4B3791B-54BC-3BF9-83CA-B5D7D3FC8BD7> /usr/lib/libcsfde.dylib
       0x1a40a0000 -        0x1a40a0fff  com.apple.ApplicationServices (48 - 50) <5FAA3FF0-EC9B-3A66-A99D-70FFAC23EA29> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/ApplicationServices
       0x1a4386000 -        0x1a4386fff  libHeimdalProxy.dylib (79) <42592F61-568E-322B-B5DF-9C69A33E9000> /System/Library/Frameworks/Kerberos.framework/Versions/A/Libraries/libHeimdalProxy.dylib
       0x1a4431000 -        0x1a4431fff  com.apple.audio.units.AudioUnit (1.14 - 1.14) <E2E442D0-D865-3703-9B74-3C2BE1190D42> /System/Library/Frameworks/AudioUnit.framework/Versions/A/AudioUnit
       0x1a4db8000 -        0x1a4dbefff  com.apple.ASEProcessing (1.26.0 - 1.26.0) <D50AB8C9-1C75-3072-A18E-161237441092> /System/Library/PrivateFrameworks/ASEProcessing.framework/Versions/A/ASEProcessing
       0x1a5d50000 -        0x1a5d53fff  com.apple.Cocoa (6.11 - 23) <E07A10C4-E5C3-39CD-9231-C91BF75E29DB> /System/Library/Frameworks/Cocoa.framework/Versions/A/Cocoa
       0x1a627b000 -        0x1a627efff  com.apple.IOSurfaceAccelerator (1.0.0 - 1.0.0) <C57E5066-EC50-3E8D-8883-E9D0DB9D5A85> /System/Library/PrivateFrameworks/IOSurfaceAccelerator.framework/Versions/A/IOSurfaceAccelerator
       0x1a94f5000 -        0x1a9516fff  com.apple.IOGPU (20.21.1 - 20.21.1) <A87744EB-C1F5-31ED-BE39-B71692DC97FA> /System/Library/PrivateFrameworks/IOGPU.framework/Versions/A/IOGPU
       0x1aa192000 -        0x1aa195fff  com.apple.OSAServicesClient (1.0 - 1) <512E9139-6E20-3E01-AA0C-5AC2D2AF3656> /System/Library/PrivateFrameworks/OSAServicesClient.framework/Versions/A/OSAServicesClient
       0x1ae059000 -        0x1ae075fff  com.apple.private.SystemPolicy (1.0 - 1) <A74ADA5D-C1DA-376E-B5A2-F3AAE208DD0C> /System/Library/PrivateFrameworks/SystemPolicy.framework/Versions/A/SystemPolicy
       0x1ae9c6000 -        0x1ae9d1fff  com.apple.MallocStackLogging (1.0 - 1) <CE8B1F36-F650-397C-AC25-E9C22C4B8747> /System/Library/PrivateFrameworks/MallocStackLogging.framework/Versions/A/MallocStackLogging
       0x1ae9e7000 -        0x1ae9f9fff  libmis.dylib (274.60.2) <75205B54-301C-32A2-9F78-5CA68144EDD4> /usr/lib/libmis.dylib
       0x1b2369000 -        0x1b2381fff  libCGInterfaces.dylib (544) <E7E7FB73-B3FD-3A36-9436-8D1B1C9BC3EE> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vImage.framework/Versions/A/Libraries/libCGInterfaces.dylib
       0x1b89d8000 -        0x1b8a21fff  com.apple.osanalytics.OSAnalytics (1.0 - 1) <E444D45A-16C6-3D81-9F9E-F1480954B314> /System/Library/PrivateFrameworks/OSAnalytics.framework/Versions/A/OSAnalytics
       0x1c260b000 -        0x1c269dfff  com.apple.Symbolication (12.2 - 64541.7.1) <4D8C25CC-A99D-3278-AF7C-82234882DF72> /System/Library/PrivateFrameworks/Symbolication.framework/Versions/A/Symbolication
       0x1d25f9000 -        0x1d25fdfff  libmetal_timestamp.dylib (31001.160) <138EA401-9B10-3CCD-8C52-8AAEC870F9DD> /System/Library/PrivateFrameworks/GPUCompiler.framework/Versions/31001/Libraries/libmetal_timestamp.dylib
       0x1d4852000 -        0x1d4858fff  libCoreFSCache.dylib (177.22) <4DD54172-58DD-3354-9237-24240736ED23> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libCoreFSCache.dylib
       0x1d4859000 -        0x1d485efff  libCoreVMClient.dylib (177.22) <A7D89B20-2B56-3AA7-BF8D-E4FFCBEB6B06> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libCoreVMClient.dylib
       0x1d485f000 -        0x1d486efff  com.apple.opengl (18.1.1 - 18.1.1) <DE64D1BB-B8A8-33F3-ADBE-CEEAE6D95C27> /System/Library/Frameworks/OpenGL.framework/Versions/A/OpenGL
       0x1d486f000 -        0x1d4871fff  libCVMSPluginSupport.dylib (18.1.1) <8A8A2DC0-921E-3325-ACBA-365D1BC4680F> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libCVMSPluginSupport.dylib
       0x1d4872000 -        0x1d487afff  libGFXShared.dylib (18.1.1) <87B86869-7D32-3408-B85C-5D3EE7572552> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGFXShared.dylib
       0x1d487b000 -        0x1d48b3fff  libGLImage.dylib (18.1.1) <8200AF5B-F339-3B05-971F-BAD8C3D7B6EC> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGLImage.dylib
       0x1d48b4000 -        0x1d48ecfff  libGLU.dylib (18.1.1) <504D710E-7F8B-33CE-8F02-E7D35E0D2A39> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGLU.dylib
       0x1d4a5c000 -        0x1d4a66fff  libGL.dylib (18.1.1) <146816E2-8322-3944-99A6-23C431D8E79E> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib
       0x1d4bf7000 -        0x1d4c56fff  com.apple.opencl (4.5 - 4.5) <248E1DE7-6AAC-3130-A8BC-72745BB9583C> /System/Library/Frameworks/OpenCL.framework/Versions/A/OpenCL
       0x1e2fc2000 -        0x1e2fc9fff  libRosetta.dylib (203.13.2) <F36DDACF-B46B-3813-8ADE-A275209588BF> /usr/lib/libRosetta.dylib

External Modification Summary:
  Calls made by other processes targeting this process:
    task_for_pid: 0
    thread_create: 0
    thread_set_state: 0
  Calls made by this process:
    task_for_pid: 0
    thread_create: 0
    thread_set_state: 0
  Calls made by all processes on this machine:
    task_for_pid: 1527408
    thread_create: 0
    thread_set_state: 290

VM Region Summary:
ReadOnly portion of Libraries: Total=674.9M resident=0K(0%) swapped_out_or_unallocated=674.9M(100%)
Writable regions: Total=1.6G written=0K(0%) resident=0K(0%) swapped_out=0K(0%) unallocated=1.6G(100%)
 
                                VIRTUAL   REGION 
REGION TYPE                        SIZE    COUNT (non-coalesced) 
===========                     =======  ======= 
Accelerate framework               640K        5 
Activity Tracing                   256K        1 
CG backing stores                 2304K        6 
CG image                            48K        2 
CoreAnimation                     5280K        9 
CoreGraphics                        32K        2 
CoreUI image data                 1040K        6 
Foundation                          16K        1 
Kernel Alloc Once                   32K        1 
MALLOC                           282.5M       63 
MALLOC guard page                  192K       10 
MALLOC_MEDIUM (reserved)         960.0M        8         reserved VM address space (unallocated)
MALLOC_NANO (reserved)           384.0M        1         reserved VM address space (unallocated)
STACK GUARD                       56.1M        9 
Stack                             15.7M        9 
VM_ALLOCATE                       1424K       26 
__AUTH                             617K      142 
__AUTH_CONST                      8822K      286 
__CTF                               759        1 
__DATA                            5230K      274 
__DATA_CONST                      11.1M      283 
__DATA_DIRTY                       593K      101 
__FONT_DATA                          4K        1 
__LINKEDIT                       487.2M        9 
__OBJC_CONST                      1203K      123 
__OBJC_RO                         64.5M        1 
__OBJC_RW                         2544K        1 
__TEXT                           187.8M      302 
__UNICODE                          588K        1 
mapped file                       75.0M       21 
shared memory                       64K        4 
===========                     =======  ======= 
TOTAL                              2.5G     1709 
TOTAL, minus reserved VM space     1.2G     1709 

Model: MacBookAir10,1, BootROM 6723.61.3, proc 8:4:4 processors, 8 GB, SMC 
Graphics: kHW_AppleM1Item, Apple M1, spdisplays_builtin
Memory Module: lp_ddr4
AirPort: spairport_wireless_card_type_airport_extreme, wl0: Oct 20 2020 12:49:54 version 18.20.222.14.7.8.100 FWID 01-ba327c2d
Bluetooth: Version 8.0.2f9, 3 services, 27 devices, 1 incoming serial ports
Network Service: Wi-Fi, AirPort, en0
USB Device: USB 3.1 Bus
USB Device: USB 3.1 Bus
Thunderbolt Bus: MacBook Air, Apple Inc., 0.0
Thunderbolt Bus: MacBook Air, Apple Inc., 0.0

logs.txt (71,671 bytes)   

Igor Kokarev

2020-12-18 16:50

reporter   ~0127671

FPC 3.2.1 fixes (downloaded today) has the same problem.

Igor Kokarev

2020-12-18 17:51

reporter   ~0127673

Probably FPU exception occurs in macOS function called from non-main thread. And this situation incorrectly processed by FPC on M1?

Jonas Maebe

2020-12-18 18:22

manager   ~0127675

Last edited: 2020-12-18 18:24

View 2 revisions

The crash log is not useful An exception is raised somewhere, not caught anywhere in the thread, so the program terminates. And then, during the termination, some Metal data structure is freed incorrectly and the program aborts.

LLDB shows that the original error is an access violation (a store to address 0). That has nothing to do with the FPU or its exceptions. Are you certain you are locking everything correctly, and that you are allowed to call this API from a different thread under the conditions? The AArch64 architecture has a much weaker memory model than Intel, so incorrect locking can much more easily lead to crashes there. Different implementations (i.e., M1 vs the A12Z in the DTK) can also have different behaviour in case of data races (depending on how much instruction and memory parallelism they have).

Igor Kokarev

2020-12-18 20:00

reporter   ~0127678

Jonas, thanks for your reply. I admit that it may be our mistake.
In attached test project, we create and work with Metal graphics from solely from another thread. The main thread does nothing. No concurency of threads. Another thread creates Metal device, performs offscreening rendering and tries to capture texture data.
It crashes inside Metal function CopyFromTexture.

Jonas Maebe

2020-12-18 20:17

manager   ~0127679

At least this declaration is wrong:

    function colorAttachmentAtIndex(index: integer): MTLRenderPassColorAttachmentDescriptor; message 'colorAttachmentAtIndex:';

Never use Pascal types when importing external APIs. Always use the original API types (NSUInteger in this case). "Integer" is a 32 bit signed integer in {$mode objfpc}. NSUInteger is a 64 bit untyped integer on (non-WatchOS) 64 bit systems. I'm not saying this will fix it, but you definitely should go over all of your imports and ensure they use the correct types.

Igor Kokarev

2020-12-18 20:30

reporter   ~0127680

Jonas, you're right. We'll check other imports to make sure that all they use correct types. Thanks.

Jonas Maebe

2020-12-19 16:16

manager   ~0127694

Also, which copyFromTexture function does it crash in? There are 35 functions with that name in memory while running the program. Please ask for the result of the following commands when it crashes in lldb:

register read
register read -s 1
bt

Igor Kokarev

2020-12-20 09:19

reporter   ~0127712

Last edited: 2020-12-20 09:20

View 2 revisions

CopyFromTexture function is called only once from Copier object (MTLBlitCommandEncoderProtocol) in my app.
I guess that CopyFromTexture is also used by macOS to render NSWindow and all UI in macOS.

Please excuse my ignorance, how I can perform these commands? I use "LLDB debugger (with fpdebug) (Beta)" in Lazarus.

Jonas Maebe

2020-12-20 13:58

manager   ~0127714

In terminal, change to the directory containing your application bundle and run
  lldb project1.app/Contents/MacOS/project1

Then in lldb, type "run"

When it crashes, enter the commands I mentioned.

Igor Kokarev

2020-12-20 17:35

reporter   ~0127723

GPU: <AGXM1Device: 0x10105c200>
    name = Apple M1
<_MTLLibrary: 0x107f1b810>
    label = <none>
    device = <AGXM1Device: 0x10105c200>
        name = Apple M1
    functionNames: vertexShader fragmentShader
bundle path= /Users/mac/WnSoft/PTE/Tests/Graphics/metal2/
Process 8823 stopped
* thread 0000010, stop reason = EXC_BAD_INSTRUCTION (code=1, subcode=0x1e220820)
    frame #0: 0x0000000115e5cee0 AGXMetal13_3`___lldb_unnamed_symbol2026$$AGXMetal13_3 + 160
AGXMetal13_3`___lldb_unnamed_symbol2026$$AGXMetal13_3:
-> 0x115e5cee0 <+160>: fmul s0, s1, s2
    0x115e5cee4 <+164>: fcmp s0, #0.0
    0x115e5cee8 <+168>: mov w13, #0x44600000
    0x115e5ceec <+172>: fmov s1, w13
Target 0: (project1) stopped.
(lldb) register read
General Purpose Registers:
        x0 = 0x0000000170666198
        x1 = 0x0000000170666120
        x2 = 0x0000000000000000
        x3 = 0x0000000000000000
        x4 = 0x0000000000000000
        x5 = 0x0000000000010000
        x6 = 0x0000000000000001
        x7 = 0x0000000000000000
        x8 = 0x0000000000000000
        x9 = 0x0000000000000001
       x10 = 0x0000000000000000
       x11 = 0x0000000000000000
       x12 = 0x0000000000000000
       x13 = 0x0000000000000000
       x14 = 0x0000000000020202
       x15 = 0x000000000000004e
       x16 = 0x000000033a307094
       x17 = 0x0000000116197ce8 (void *)0x00000001ac4acc3c: IOGPUResourceListAddResource
       x18 = 0x0000000000000000
       x19 = 0x0000000110815000
       x20 = 0x0000000150013eb8
       x21 = 0x0000000170666440
       x22 = 0x0000000170666830
       x23 = 0x0000000170666638
       x24 = 0x000000011083b600
       x25 = 0x0003bc13f6884a22
       x26 = 0x0000000000000000
       x27 = 0xc00000c000000000
       x28 = 0x0000000000000018
        fp = 0x0000000170666390
        lr = 0x0000000116103050 AGXMetal13_3`___lldb_unnamed_symbol3546$$AGXMetal13_3 + 2008
        sp = 0x00000001706660d0
        pc = 0x0000000115e5cee0 AGXMetal13_3`___lldb_unnamed_symbol2026$$AGXMetal13_3 + 160
      cpsr = 0x60001000

(lldb) register read -s 1
Floating Point Registers:
        v0 = {0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
        v1 = {0xff 0xff 0x7f 0x7f 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
        v2 = {0x00 0x00 0x80 0x42 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
        v3 = {0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
        v4 = {0x33 0x4e 0x9a 0xb4 0x06 0xe0 0x6c 0x46 0xac 0x6c 0xe4 0xd4 0xe2 0x87 0x69 0x7b}
        v5 = {0xaf 0x06 0x0a 0x4d 0x71 0x4c 0x5b 0x80 0x9a 0xe5 0x9e 0x40 0x46 0xfe 0x95 0x59}
        v6 = {0xe0 0x9e 0xe5 0x5b 0xb8 0x8a 0x6f 0x5c 0x31 0x00 0x56 0x34 0x13 0x2e 0x68 0x84}
        v7 = {0x77 0xf9 0x86 0x1b 0x0f 0x6c 0x58 0x68 0x27 0x0b 0x7e 0xc2 0xac 0x42 0x9d 0x5d}
        v8 = {0x00 0x00 0x80 0x3f 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
        v9 = {0x00 0x00 0x70 0x43 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
       v10 = {0x00 0x00 0xa0 0x43 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
       v11 = {0x00 0x00 0x80 0x3f 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
       v12 = {0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
       v13 = {0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
       v14 = {0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
       v15 = {0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
       v16 = {0x9a 0x7a 0x44 0x51 0x4a 0x6c 0xdf 0x68 0xd3 0x47 0xf3 0x94 0x26 0xf7 0x04 0xbf}
       v17 = {0x7e 0xe2 0xea 0x04 0xd8 0x8c 0x7f 0xf7 0x12 0x20 0x13 0x61 0x7a 0x81 0xc3 0xbe}
       v18 = {0x7f 0xd5 0x91 0x78 0xf1 0x41 0x66 0x76 0x20 0x6d 0xbe 0x2e 0x6f 0x8e 0x88 0x31}
       v19 = {0xd7 0x90 0x07 0x01 0x92 0x28 0xd9 0xaf 0xdd 0x91 0xba 0x20 0x15 0x83 0x00 0x18}
       v20 = {0x50 0xef 0x39 0x8a 0x02 0x44 0x46 0xff 0x18 0x06 0x27 0x4a 0xe9 0xa2 0x56 0x70}
       v21 = {0x16 0xc1 0xa4 0x19 0x08 0x6c 0x37 0x1e 0x4c 0x77 0x48 0x27 0xb5 0xbc 0xb0 0x34}
       v22 = {0xb3 0x0c 0x1c 0x39 0x4a 0xaa 0xd8 0x4e 0x4f 0xca 0x9c 0x5b 0xf3 0x6f 0x2e 0x68}
       v23 = {0xee 0x82 0x8f 0x74 0x6f 0x63 0xa5 0x78 0x14 0x78 0xc8 0x84 0x08 0x02 0xc7 0x8c}
       v24 = {0xfa 0xff 0xbe 0x90 0xeb 0x6c 0x50 0xa4 0xf7 0xa3 0xf9 0xbe 0xf2 0x78 0x71 0xc6}
       v25 = {0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
       v26 = {0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
       v27 = {0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
       v28 = {0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
       v29 = {0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
       v30 = {0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
       v31 = {0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00}
      fpsr = 0x00000010
      fpcr = 0x00000700
        s0 = 0
        s1 = 3.40282e+38
        s2 = 64
        s3 = 0
        s4 = -2.87416e-07
        s5 = 1.44731e+08
        s6 = 1.29265e+17
        s7 = 2.23297e-22
        s8 = 1
        s9 = 240
       s10 = 320
       s11 = 1
       s12 = 0
       s13 = 0
       s14 = 0
       s15 = 0
       s16 = 5.27419e+10
       s17 = 5.52211e-36
       s18 = 2.36629e+34
       s19 = 2.48995e-38
       s20 = -8.95244e-33
       s21 = 1.70352e-23
       s22 = 0.000148821
       s23 = 9.09612e+31
       s24 = -7.53362e-29
       s25 = 0
       s26 = 0
       s27 = 0
       s28 = 0
       s29 = 0
       s30 = 0
       s31 = 0
        d0 = 0
        d1 = 1.05685337195934e-314
        d2 = 5.51221562887463e-315
        d3 = 0
        d4 = 1.83017703922136e+31
        d5 = -6.07414097671278e-307
        d6 = 1.83406852952982e+137
        d7 = 4.45697624816435e+194
        d8 = 5.26354424712089e-315
        d9 = 5.58992543567268e-315
       d10 = 5.60546739703229e-315
       d11 = 5.26354424712089e-315
       d12 = 0
       d13 = 0
       d14 = 0
       d15 = 0
       d16 = 1.46806387265077e+197
       d17 = -4.06928293381029e+267
       d18 = 2.19020312621553e+262
       d19 = -3.39488836336422e-78
       d20 = -1.22152193842246e+305
       d21 = 4.06730096217846e-163
       d22 = 6.80931679437946e+71
       d23 = 1.44632128139263e+273
       d24 = -9.03940249407454e-134
       d25 = 0
       d26 = 0
       d27 = 0
       d28 = 0
       d29 = 0
       d30 = 0
       d31 = 0

(lldb) bt
* thread 0000010, stop reason = EXC_BAD_INSTRUCTION (code=1, subcode=0x1e220820)
  * frame #0: 0x0000000115e5cee0 AGXMetal13_3`___lldb_unnamed_symbol2026$$AGXMetal13_3 + 160
    frame 0000001: 0x0000000116103050 AGXMetal13_3`___lldb_unnamed_symbol3546$$AGXMetal13_3 + 2008
    frame 0000002: 0x000000011610db10 AGXMetal13_3`___lldb_unnamed_symbol3602$$AGXMetal13_3 + 916
    frame 0000003: 0x00000001161126a8 AGXMetal13_3`___lldb_unnamed_symbol3622$$AGXMetal13_3 + 372
    frame 0000004: 0x0000000100378e3c project1`SAVETOBMP(this=0x0000000116658040, FN="/Users/mac/WnSoft/PTE/Tests/Graphics/metal2/RenderAsync.bmp") at mymetal.pas:562:3
    frame 0000005: 0x0000000100379c54 project1`DRAWTO(this=0x0000000116658040, FN=0x0000000100387578) at mymetal.pas:655:37
    frame 0000006: 0x0000000100052928 project1`RENDER(FN=0x0000000100387578) at unit1.pas:45:3
    frame 0000007: 0x00000001000529a0 project1`THREADFUNC(P=0x0000000000000000) at unit1.pas:52:27
    frame 0000008: 0x000000010003425c project1`CTHREADS_$$_THREADMAIN$POINTER$$POINTER + 140
    frame 0000009: 0x000000019511906c libsystem_pthread.dylib`_pthread_start + 320
UFV3ckplaS9HbW1DQT09

Jonas Maebe

2020-12-20 18:30

manager   ~0127725

Okay, so it is in fact an FPU overflow exception in the end. On Darwin/i386 and Darwin/x86-64, the gl (!) unit mask all FPU exceptions on startup. While I don't immediately see where, I suppose it gets also included in every Lazarus Cocoa application (I can only find references from the Carbon widgetset). I will add it also for AArch64, but maybe it's better to do this somewhere in the LCL (as well) to be more future proof.

For now, you should be able to solve the issue by adding this to your program:

uses
  Math;

...

SetExceptionMask([exInvalidOp, exDenormalized, exZeroDivide,exOverflow, exUnderflow, exPrecision]);

Florian

2020-12-20 18:47

administrator   ~0127727

It might be also that math is buggy in this regard, I think the aarch64 exception masking code was never tested as I never had access to an aarch64 implementation supporting floating point exceptions.

Jonas Maebe

2020-12-20 19:06

manager   ~0127730

Looking at the backtrace and the register state (combined with the lldb code dump in the original attachment), it's multiplying maxsingle (or something close to it) with 64 and thereby triggering an fpu overflow exception (inside a Metal shader, so not in FPC-generated code).

Igor Kokarev

2020-12-20 20:25

reporter   ~0127734

Last edited: 2020-12-20 20:26

View 2 revisions

Jonas,
Thank you very much for your generous help! I fixed this problem with adding SetExceptionMask()
Strange thing, I added this function in the main thread and it didn't work! Then I tried to add SetExceptionMask() in the second thread where I create offscreen Metal device and perform rendering. And now it worked!
I create a second thread by calling System.BeginThread()
Then I added this code for my real app and now it also works fine. It also fixed strange problems with audio decoders after adding SetExceptionMask for every audio decoding thread.
I'll check Metal shader for calculations of intel and single types as you wrote.
Now we can publish our app for Apple Silicon as Beta version - all features work fine.

Jonas Maebe

2020-12-20 22:45

manager   ~0127737

That's actually interesting: on AArch64, in each thread we indeed initially set the fpu control so that the rounding mode and fpu exceptions are back on their defaults (in SysInitFPU). On e.g. i386 and x86-64, we don't do that (we only do it on program startup there, in fpc_cpuinit). So that seems to be a bug. Normally you should only have to change it once in your main program.

Igor Kokarev

2020-12-21 10:41

reporter   ~0127741

Last edited: 2020-12-21 10:41

View 2 revisions

Jonas,
1. Do I understand rightly that normally (by default) FPC can generate FPU exceptions for Pascal code and system OS functions should NOT generate any FPU exceptions? In main thread or in any thread.
2. If Metal shaders may cause FPU exception, probably macOS add a special type (flag) for these exceptions, so we can determine that this exception came from Metal shaders. Probably it would better to hide these exceptions by default?
You can send me test apps, which I'll run in lldb to send you logs if you need to check how FPU exceptions work on M1.

Issue History

Date Modified Username Field Change
2020-12-18 16:21 Igor Kokarev New Issue
2020-12-18 16:21 Igor Kokarev File Added: metal2.zip
2020-12-18 16:21 Igor Kokarev File Added: logs.txt
2020-12-18 16:50 Igor Kokarev Note Added: 0127671
2020-12-18 17:51 Igor Kokarev Note Added: 0127673
2020-12-18 18:22 Jonas Maebe Note Added: 0127675
2020-12-18 18:24 Jonas Maebe Note Edited: 0127675 View Revisions
2020-12-18 20:00 Igor Kokarev Note Added: 0127678
2020-12-18 20:17 Jonas Maebe Note Added: 0127679
2020-12-18 20:30 Igor Kokarev Note Added: 0127680
2020-12-19 16:16 Jonas Maebe Note Added: 0127694
2020-12-20 09:19 Igor Kokarev Note Added: 0127712
2020-12-20 09:20 Igor Kokarev Note Edited: 0127712 View Revisions
2020-12-20 13:58 Jonas Maebe Note Added: 0127714
2020-12-20 17:35 Igor Kokarev Note Added: 0127723
2020-12-20 18:30 Jonas Maebe Note Added: 0127725
2020-12-20 18:47 Florian Note Added: 0127727
2020-12-20 19:06 Jonas Maebe Note Added: 0127730
2020-12-20 20:25 Igor Kokarev Note Added: 0127734
2020-12-20 20:26 Igor Kokarev Note Edited: 0127734 View Revisions
2020-12-20 22:45 Jonas Maebe Note Added: 0127737
2020-12-21 10:41 Igor Kokarev Note Added: 0127741
2020-12-21 10:41 Igor Kokarev Note Edited: 0127741 View Revisions
2021-04-13 20:33 Jonas Maebe Relationship added has duplicate 0038750